import { jsx } from 'react/jsx-runtime';
import { forwardRef } from 'react';
import { useTrackingId } from './useTrackingId.js';
import { A as Alert$1 } from './Alert-DMk5bG5T-kR7Uzp64.js';

const Alert = forwardRef(
  (props, ref) => {
    const data = {
      title: props.title,
      status: props.status
    };
    const trackingId = useTrackingId({
      name: "Alert",
      data,
      hasOverride: !!props["data-tracking-id"]
    });
    return /* @__PURE__ */ jsx(Alert$1, { ref, "data-tracking-id": trackingId, ...props });
  }
);

export { Alert as A };
//# sourceMappingURL=Alert-BsFFiu7g.js.map
