import { jsxs, jsx } from 'react/jsx-runtime';
import { forwardRef } from 'react';
import { useTrackingId } from './useTrackingId.js';
import { c as cx } from './index-tZvMCc77.js';
import { B as Button } from './Button-C-QpfgfF-CRBE7KiD.js';
import { S as SvgClose } from './close-DZj38AEh.js';
import { S as SvgError, a as SvgCheckCircle, b as SvgInfo } from './check_circle-BGfigqq-.js';
import { S as SvgWarning } from './warning-c4Wj1rI4.js';
import { I as Icon } from './Icon-BrdmZw1i-CG-LzgEz.js';
import { u as useLayoutPropsUtil } from './useLayoutPropsUtil-GT5myWCm-Clw_nEze.js';

import './Announcement.css';const announcement = "_announcement_26ioj_2";
const title = "_title_26ioj_44";
const success = "_success_26ioj_61";
const warning = "_warning_26ioj_68";
const danger = "_danger_26ioj_75";
const styles = {
	announcement: announcement,
	"close-container": "_close-container_26ioj_35",
	"title-container": "_title-container_26ioj_44",
	title: title,
	"status-icon": "_status-icon_26ioj_58",
	success: success,
	warning: warning,
	danger: danger,
	"close-button": "_close-button_26ioj_84"
};

const statusIconMap = {
  info: SvgInfo,
  success: SvgCheckCircle,
  warning: SvgWarning,
  danger: SvgError
};
const Announcement$1 = forwardRef(
  (props, ref) => {
    const { layoutStyles, componentProps } = useLayoutPropsUtil(props);
    const {
      className,
      title,
      status = "info",
      children,
      style,
      onClose,
      ...rest
    } = componentProps;
    const styleCombined = {
      ...style,
      ...layoutStyles
    };
    const AnnouncementCx = cx(styles["announcement"], className, {
      [styles["success"]]: status === "success",
      [styles["warning"]]: status === "warning",
      [styles["danger"]]: status === "danger"
    });
    return /* @__PURE__ */ jsxs(
      "div",
      {
        role: "status",
        className: AnnouncementCx,
        "data-anv": "announcement",
        style: styleCombined,
        ...rest,
        ref,
        children: [
          /* @__PURE__ */ jsxs("span", { className: styles["title-container"], children: [
            /* @__PURE__ */ jsx(
              Icon,
              {
                size: "large",
                className: styles["status-icon"],
                svg: statusIconMap[status]
              }
            ),
            /* @__PURE__ */ jsx("span", { className: styles["title"], children: title })
          ] }),
          children,
          onClose ? /* @__PURE__ */ jsx("span", { className: styles["close-container"], children: /* @__PURE__ */ jsx(
            Button,
            {
              icon: SvgClose,
              size: "small",
              appearance: "ghost",
              className: styles["close-button"],
              onClick: (e) => onClose(e),
              "aria-label": `Dismiss ${status} announcement`
            }
          ) }) : null
        ]
      }
    );
  }
);
Announcement$1.displayName = "Announcement";

const Announcement = forwardRef(
  (props, ref) => {
    const data = {
      title: props.title,
      status: props.status
    };
    const trackingId = useTrackingId({
      name: "Announcement",
      data,
      hasOverride: !!props["data-tracking-id"]
    });
    return /* @__PURE__ */ jsx(Announcement$1, { ref, "data-tracking-id": trackingId, ...props });
  }
);

export { Announcement as A };
//# sourceMappingURL=Announcement-BawOyXV3.js.map
