import { jsxs, jsx } from 'react/jsx-runtime';
import { forwardRef } from 'react';
import { c as cx } from './index-tZvMCc77.js';
import { S as SrOnly } from './SrOnly-BsKDHetF-B93X65F1.js';
import { u as useLayoutPropsUtil } from './useLayoutPropsUtil-GT5myWCm-Clw_nEze.js';

import './Badge.css';const badge = "_badge_1rwnm_2";
const empty = "_empty_1rwnm_43";
const styles = {
	badge: badge,
	empty: empty
};

const Badge$1 = forwardRef((props, ref) => {
  const { layoutStyles, componentProps } = useLayoutPropsUtil(props);
  const {
    offset,
    children,
    style,
    className,
    "aria-label": ariaLabel,
    ...rest
  } = componentProps;
  const classNames = cx(styles["badge"], className, {
    [styles.empty]: !children
  });
  const offsetX = offset?.x ?? `0px`;
  const offsetY = offset?.y ?? `0px`;
  const iStyle = {
    ...style,
    ...layoutStyles,
    "--offsetY": offsetY,
    "--offsetX": offsetX
  };
  return /* @__PURE__ */ jsxs(
    "sup",
    {
      className: classNames,
      style: iStyle,
      "data-anv": "badge",
      ...rest,
      ref,
      children: [
        /* @__PURE__ */ jsx(SrOnly, { children: ariaLabel }),
        children
      ]
    }
  );
});
Badge$1.displayName = "Badge";

const Badge = forwardRef(
  (props, ref) => {
    return /* @__PURE__ */ jsx(Badge$1, { ref, ...props });
  }
);

export { Badge as B };
//# sourceMappingURL=Badge-Bko3Cw3L.js.map
