import { jsx, jsxs, Fragment } from 'react/jsx-runtime';
import * as React from 'react';
import { forwardRef, Children, cloneElement } from 'react';
import { c as cx } from './index-tZvMCc77.js';
import { L as Link } from './Link-CVN5Mwtx-B08PO1ef.js';
import { T as Text } from './Text-CN_-FF7J-Dzoy8A70.js';
import { u as useLayoutPropsUtil } from './useLayoutPropsUtil-GT5myWCm-Clw_nEze.js';
import { I as Icon } from './Icon-BrdmZw1i-CG-LzgEz.js';

import './Breadcrumbs.css';const SvgChevronRight = (props) => /* @__PURE__ */ React.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", width: "1em", height: "1em", viewBox: "0 0 24 24", ...props }, /* @__PURE__ */ React.createElement("path", { d: "M10 6 8.59 7.41 13.17 12l-4.58 4.59L10 18l6-6z" }));

const breadcrumbs = "_breadcrumbs_1c7ez_2";
const styles = {
	breadcrumbs: breadcrumbs,
	"breadcrumbs-link": "_breadcrumbs-link_1c7ez_18"
};

const BreadcrumbsLink$1 = forwardRef((props, ref) => {
  const { layoutStyles, componentProps } = useLayoutPropsUtil(props);
  const { children, className, style, ...rest } = componentProps;
  const classes = cx([styles["breadcrumbs-link"]], className, {});
  const styleCombined = {
    ...style,
    ...layoutStyles
  };
  return /* @__PURE__ */ jsx(
    Link,
    {
      tabIndex: 0,
      "data-anv": "breadcrumbs-link",
      style: styleCombined,
      appearance: "secondary",
      className: classes,
      ...rest,
      ref,
      children: /* @__PURE__ */ jsx(Text, { size: "small", inline: true, children })
    }
  );
});
BreadcrumbsLink$1.displayName = "BreadcrumbsLink";

const BreadcrumbsElement$1 = forwardRef(
  (props, ref) => {
    const { layoutStyles, componentProps } = useLayoutPropsUtil(props);
    const { children, className, style, ...rest } = componentProps;
    const classes = cx([styles["breadcrumbs"]], className, {});
    const styleCombined = {
      ...style,
      ...layoutStyles
    };
    const linkCount = Children.count(children);
    return /* @__PURE__ */ jsx(
      "nav",
      {
        "data-anv": "breadcrumbs",
        style: styleCombined,
        className: classes,
        "aria-label": "Breadcrumb",
        ...rest,
        ref,
        children: Children.map(children, (link, i) => {
          if (i + 1 === linkCount) {
            return /* @__PURE__ */ jsx(
              Text,
              {
                inline: true,
                size: "small",
                style: {
                  fontWeight: "bold"
                },
                children: link.props.children
              }
            );
          } else {
            return /* @__PURE__ */ jsxs(Fragment, { children: [
              cloneElement(link),
              /* @__PURE__ */ jsx(Icon, { svg: SvgChevronRight, "aria-hidden": "true" })
            ] });
          }
        })
      }
    );
  }
);
BreadcrumbsElement$1.displayName = "Breadcrumbs";
const Breadcrumbs$1 = Object.assign(BreadcrumbsElement$1, {
  Link: BreadcrumbsLink$1
});

const BreadcrumbsElement = forwardRef(
  (props, ref) => {
    return /* @__PURE__ */ jsx(Breadcrumbs$1, { ref, ...props });
  }
);
const BreadcrumbsLink = forwardRef(
  (props, ref) => {
    return /* @__PURE__ */ jsx(BreadcrumbsLink$1, { ref, ...props });
  }
);
const Breadcrumbs = Object.assign(BreadcrumbsElement, {
  Link: BreadcrumbsLink
});

export { Breadcrumbs as B, BreadcrumbsElement as a, BreadcrumbsLink as b };
//# sourceMappingURL=Breadcrumbs-BP5QXVje.js.map
