import { jsx } from 'react/jsx-runtime';
import { forwardRef } from 'react';
import { useTrackingId } from './useTrackingId.js';
import { c as childrenToString } from './childrenToString-Bz9MqbHb-Bz9MqbHb.js';
import { B as ButtonCompound$1 } from './ButtonCompound-Dp5J4W81-BkZ68L4-.js';

const ButtonCompound = forwardRef(
  (props, ref) => {
    const data = {
      children: childrenToString(props.children),
      shape: props.shape,
      type: props.type
    };
    const trackingId = useTrackingId({
      name: "ButtonCompound",
      data,
      hasOverride: !!props["data-tracking-id"]
    });
    return /* @__PURE__ */ jsx(ButtonCompound$1, { ref, "data-tracking-id": trackingId, ...props });
  }
);

export { ButtonCompound as B };
//# sourceMappingURL=ButtonCompound-DlgIyoB9.js.map
