import { jsx } from 'react/jsx-runtime';
import { forwardRef } from 'react';
import { c as cx } from './index-tZvMCc77.js';
import { s as styles } from './Button.module-BqTaW8HK-BqTaW8HK.js';
import { u as useLayoutPropsUtil } from './useLayoutPropsUtil-GT5myWCm-Clw_nEze.js';

const ButtonCompound = forwardRef((props, ref) => {
  const { layoutStyles, componentProps } = useLayoutPropsUtil(props);
  const {
    className,
    shape = "rounded",
    type,
    disabled,
    children,
    style,
    ...rest
  } = componentProps;
  const buttonClassNames = cx(
    className,
    styles["button"],
    styles["button-compound"],
    {
      [styles["shape-pill"]]: shape === "pill",
      [styles["shape-circular"]]: shape === "circular",
      [styles["shape-rounded"]]: shape === "rounded"
    }
  );
  const styleCombined = {
    ...style,
    ...layoutStyles
  };
  return /* @__PURE__ */ jsx(
    "button",
    {
      className: buttonClassNames,
      type,
      disabled,
      "data-anv": "button-compound",
      ref,
      style: styleCombined,
      ...rest,
      children
    }
  );
});
ButtonCompound.displayName = "ButtonCompound";

export { ButtonCompound as B };
//# sourceMappingURL=ButtonCompound-Dp5J4W81-BkZ68L4-.js.map
