import { jsx } from 'react/jsx-runtime';
import { forwardRef } from 'react';
import { useTrackingId } from './useTrackingId.js';
import { c as childrenToString } from './childrenToString-Bz9MqbHb-Bz9MqbHb.js';
import { B as ButtonLink$1 } from './ButtonLink-CSaxjhI2-KLVGwWjE.js';

import './ButtonLink.css';const ButtonLink = forwardRef(
  (props, ref) => {
    const data = {
      children: childrenToString(props.children),
      appearance: props.appearance,
      href: props.href,
      icon: props.icon,
      size: props.size,
      type: props.type
    };
    const trackingId = useTrackingId({
      name: "ButtonLink",
      data,
      hasOverride: !!props["data-tracking-id"]
    });
    return /* @__PURE__ */ jsx(ButtonLink$1, { ref, "data-tracking-id": trackingId, ...props });
  }
);

export { ButtonLink as B };
//# sourceMappingURL=ButtonLink-B_uUWBLY.js.map
