import { jsx } from 'react/jsx-runtime';
import { forwardRef, useState, useEffect } from 'react';
import { c as cx } from './index-tZvMCc77.js';
import { B as Button } from './Button-C-QpfgfF-CRBE7KiD.js';
import { s as styles } from './Button.module-BqTaW8HK-BqTaW8HK.js';
import { u as useLayoutPropsUtil } from './useLayoutPropsUtil-GT5myWCm-Clw_nEze.js';

const ButtonToggle = forwardRef(
  (props, ref) => {
    const { layoutStyles, componentProps } = useLayoutPropsUtil(props);
    const {
      value,
      defaultChecked = false,
      checked,
      className,
      onClick,
      onChange,
      onKeyDown,
      style,
      ...rest
    } = componentProps;
    const [isPressed, setIsPressed] = useState(checked ?? defaultChecked);
    const ButtonToggleClassNames = cx(className, styles["button-toggle"]);
    const onClickHandler = (e) => {
      if (typeof checked === "undefined") {
        setIsPressed(!isPressed);
        onChange?.(e, { pressed: !isPressed, value });
      }
      onClick?.(e);
    };
    useEffect(() => {
      if (typeof checked === "undefined") return;
      setIsPressed(checked);
    }, [checked]);
    const styleCombined = {
      ...style,
      ...layoutStyles
    };
    return /* @__PURE__ */ jsx(
      Button,
      {
        "data-anv": "button-toggle",
        "aria-pressed": isPressed,
        onClick: onClickHandler,
        className: ButtonToggleClassNames,
        value,
        style: styleCombined,
        ref,
        ...rest
      }
    );
  }
);
ButtonToggle.displayName = "ButtonToggle";

export { ButtonToggle as B };
//# sourceMappingURL=ButtonToggle-CvXIngRd-BiWpOOWr.js.map
