import { jsx } from 'react/jsx-runtime';
import { forwardRef } from 'react';
import { useTrackingId } from './useTrackingId.js';
import { c as childrenToString } from './childrenToString-Bz9MqbHb-Bz9MqbHb.js';
import { B as ButtonToggle$1 } from './ButtonToggle-CvXIngRd-BiWpOOWr.js';

const ButtonToggle = forwardRef(
  (props, ref) => {
    const data = {
      children: childrenToString(props.children),
      icon: props.icon,
      size: props.size,
      value: props.value,
      type: props.type
    };
    const trackingId = useTrackingId({
      name: "ButtonToggle",
      data,
      hasOverride: !!props["data-tracking-id"]
    });
    return /* @__PURE__ */ jsx(ButtonToggle$1, { ref, "data-tracking-id": trackingId, ...props });
  }
);

export { ButtonToggle as B };
//# sourceMappingURL=ButtonToggle-D3tcTRq9.js.map
