import { jsx } from 'react/jsx-runtime';
import { forwardRef } from 'react';
import { useTrackingId } from './useTrackingId.js';
import { C as CheckboxGroup$1, a as Checkbox$1 } from './Checkbox-CRurfeRE-BR_NXfh6.js';
import { c as childrenToString } from './childrenToString-Bz9MqbHb-Bz9MqbHb.js';

const CheckboxElement = forwardRef(
  (props, ref) => {
    const data = {
      label: childrenToString(props.label),
      ariaLabel: props["aria-label"],
      ariaLabelledBy: props["aria-labelledby"],
      value: props.value
    };
    const trackingId = useTrackingId({
      name: "Checkbox",
      data,
      hasOverride: !!props["data-tracking-id"]
    });
    return /* @__PURE__ */ jsx(Checkbox$1, { ref, "data-tracking-id": trackingId, ...props });
  }
);
const CheckboxGroup = forwardRef(
  (props, ref) => {
    return /* @__PURE__ */ jsx(CheckboxGroup$1, { ref, ...props });
  }
);
const Checkbox = Object.assign(CheckboxElement, {
  Group: CheckboxGroup
});

export { Checkbox as C, CheckboxGroup as a };
//# sourceMappingURL=Checkbox-BIlp8xmW.js.map
