import { jsx } from 'react/jsx-runtime';
import { forwardRef } from 'react';
import { useTrackingId } from './useTrackingId.js';
import { C as Chip$1 } from './Chip-DwiMFYBm-CIDM1d8e.js';

const Chip = forwardRef(
  (props, ref) => {
    const data = {
      label: props.label,
      size: props.size,
      color: props.color
    };
    const trackingId = useTrackingId({
      name: "Chip",
      data,
      hasOverride: !!props["data-tracking-id"]
    });
    return /* @__PURE__ */ jsx(Chip$1, { ref, "data-tracking-id": trackingId, ...props });
  }
);
Chip.displayName = Chip$1.displayName;

export { Chip as C };
//# sourceMappingURL=Chip-BQ58RQ3v.js.map
