import { jsx } from 'react/jsx-runtime';
import { forwardRef } from 'react';
import { useTrackingId } from './useTrackingId.js';
import { c as childrenToString } from './childrenToString-Bz9MqbHb-Bz9MqbHb.js';
import { D as DrawerCancelButton$1, a as DrawerFooter$1, b as DrawerHeader$1, c as DrawerContent$1, d as Drawer$1 } from './ProgressBar-CeClhdcf-Dcft7ZjO.js';

const DrawerElement = forwardRef(
  (props, ref) => {
    return /* @__PURE__ */ jsx(Drawer$1, { ref, ...props });
  }
);
const DrawerCancelButton = forwardRef(
  (props, ref) => {
    const data = {
      children: childrenToString(props.children),
      appearance: props.appearance,
      size: props.size,
      type: props.type
    };
    const trackingId = useTrackingId({
      name: "DrawerCancelButton",
      data,
      hasOverride: !!props["data-tracking-id"]
    });
    return /* @__PURE__ */ jsx(
      DrawerCancelButton$1,
      {
        ref,
        "data-tracking-id": trackingId,
        ...props
      }
    );
  }
);
const DrawerFooter = forwardRef(
  (props, ref) => {
    return /* @__PURE__ */ jsx(DrawerFooter$1, { ref, ...props });
  }
);
const DrawerHeader = forwardRef(
  (props, ref) => {
    const data = {
      children: childrenToString(props.children)
    };
    const trackingId = useTrackingId({
      name: "DrawerHeader",
      data,
      hasOverride: !!props["data-tracking-id"]
    });
    return /* @__PURE__ */ jsx(DrawerHeader$1, { ref, "data-tracking-id": trackingId, ...props });
  }
);
const DrawerContent = forwardRef(
  (props, ref) => {
    return /* @__PURE__ */ jsx(DrawerContent$1, { ref, ...props });
  }
);
const Drawer = Object.assign(DrawerElement, {
  Header: DrawerHeader,
  Footer: DrawerFooter,
  Content: DrawerContent,
  CancelButton: DrawerCancelButton
});

export { Drawer as D, DrawerCancelButton as a, DrawerFooter as b, DrawerHeader as c, DrawerContent as d };
//# sourceMappingURL=Drawer-BFfakO8h.js.map
