import { jsxs, jsx } from 'react/jsx-runtime';
import { forwardRef } from 'react';
import { c as cx } from './index-tZvMCc77.js';
import { I as Icon } from './Icon-BrdmZw1i-CG-LzgEz.js';
import { S as SvgWarning } from './warning-c4Wj1rI4.js';

import './FieldMessage-Js4e1ezw.css';const messages = "_messages_qiebs_1";
const styles = {
	messages: messages,
	"error-container": "_error-container_qiebs_9",
	"error-icon": "_error-icon_qiebs_16"
};

const FieldMessage = forwardRef(
  (props, ref) => {
    const {
      id,
      hint,
      description,
      errorAriaLive = "assertive",
      errorMessage,
      className,
      ...rest
    } = props;
    return /* @__PURE__ */ jsxs(
      "div",
      {
        ...rest,
        className: cx(styles["messages"], className),
        ref,
        id,
        children: [
          errorMessage ? /* @__PURE__ */ jsxs("div", { className: styles["error-container"], children: [
            /* @__PURE__ */ jsx(
              Icon,
              {
                inherit: true,
                className: styles["error-icon"],
                "aria-hidden": true,
                svg: SvgWarning
              }
            ),
            /* @__PURE__ */ jsx("span", { className: styles["error-message"], "aria-live": errorAriaLive, children: errorMessage })
          ] }) : hint ?? null,
          description ? /* @__PURE__ */ jsx("div", { className: styles["description-container"], children: description ? /* @__PURE__ */ jsx("span", { children: description }) : null }) : null
        ]
      }
    );
  }
);
FieldMessage.displayName = "FieldMessage";

export { FieldMessage as F };
//# sourceMappingURL=FieldMessage-Js4e1ezw-DZ6YDx24.js.map
