import { jsx } from 'react/jsx-runtime';
import { forwardRef } from 'react';
import { c as cx } from './index-tZvMCc77.js';
import { u as useLayoutPropsUtil } from './useLayoutPropsUtil-GT5myWCm-Clw_nEze.js';

import './Grid.css';const grid = "_grid_1yq7u_2";
const styles = {
	grid: grid,
	"grid-item": "_grid-item_1yq7u_15",
	"inline-grid": "_inline-grid_1yq7u_28"
};

const Grid$1 = forwardRef((props, ref) => {
  const {
    inline,
    templateColumns,
    templateRows,
    templateAreas,
    autoColumns,
    autoRows,
    sm,
    md,
    lg,
    xl,
    xxl,
    ...nonLayoutProps
  } = props;
  const combineLayoutProps = {
    ...nonLayoutProps,
    gridTemplateColumns: props.templateColumns,
    gridTemplateRows: props.templateRows,
    gridTemplateAreas: props.templateAreas,
    gridAutoColumns: props.autoColumns,
    gridAutoRows: props.autoRows,
    sm: {
      ...sm,
      gridTemplateColumns: sm?.templateColumns,
      gridTemplateRows: sm?.templateRows,
      gridTemplateAreas: sm?.templateAreas,
      gridAutoColumns: sm?.autoColumns,
      gridAutoRows: sm?.autoRows
    },
    md: {
      ...md,
      gridTemplateColumns: md?.templateColumns,
      gridTemplateRows: md?.templateRows,
      gridTemplateAreas: md?.templateAreas,
      gridAutoColumns: md?.autoColumns,
      gridAutoRows: md?.autoRows
    },
    lg: {
      ...lg,
      gridTemplateColumns: lg?.templateColumns,
      gridTemplateRows: lg?.templateRows,
      gridTemplateAreas: lg?.templateAreas,
      gridAutoColumns: lg?.autoColumns,
      gridAutoRows: lg?.autoRows
    },
    xl: {
      ...xl,
      gridTemplateColumns: xl?.templateColumns,
      gridTemplateRows: xl?.templateRows,
      gridTemplateAreas: xl?.templateAreas,
      gridAutoColumns: xl?.autoColumns,
      gridAutoRows: xl?.autoRows
    },
    xxl: {
      ...xxl,
      gridTemplateColumns: xxl?.templateColumns,
      gridTemplateRows: xxl?.templateRows,
      gridTemplateAreas: xxl?.templateAreas,
      gridAutoColumns: xxl?.autoColumns,
      gridAutoRows: xxl?.autoRows
    }
  };
  const { layoutStyles, componentProps } = useLayoutPropsUtil(combineLayoutProps);
  const { children, className, style, ...rest } = componentProps;
  const gridClassNames = cx(className, {
    [styles["grid"]]: !inline,
    [styles["inline-grid"]]: inline
  });
  const styleCombined = {
    ...style,
    ...layoutStyles
  };
  return /* @__PURE__ */ jsx(
    "div",
    {
      className: gridClassNames,
      "data-anv": "grid",
      style: styleCombined,
      ref,
      ...rest,
      children
    }
  );
});
Grid$1.displayName = "Grid";

const GridItem = forwardRef(
  (props, ref) => {
    const { layoutStyles, componentProps } = useLayoutPropsUtil(props);
    const { className, children, style, ...rest } = componentProps;
    const gridItemClassNames = cx([styles["grid-item"]], className, {});
    const styleCombined = {
      ...style,
      ...layoutStyles
    };
    return /* @__PURE__ */ jsx(
      "div",
      {
        className: gridItemClassNames,
        "data-anv": "grid-item",
        ref,
        style: styleCombined,
        ...rest,
        children
      }
    );
  }
);
GridItem.displayName = "GridItem";

const Grid = Object.assign(Grid$1, {
  Item: GridItem
});

export { Grid as G };
//# sourceMappingURL=Grid-BmNHm7Fa.js.map
