import { jsx } from 'react/jsx-runtime';
import { forwardRef } from 'react';
import { c as cx } from './index-tZvMCc77.js';
import { u as useLayoutPropsUtil } from './useLayoutPropsUtil-GT5myWCm-Clw_nEze.js';

import './Icon-BrdmZw1i.css';const icon = "_icon_ju3rs_2";
const small = "_small_ju3rs_33";
const medium = "_medium_ju3rs_36";
const large = "_large_ju3rs_39";
const xlarge = "_xlarge_ju3rs_42";
const styles = {
	icon: icon,
	small: small,
	medium: medium,
	large: large,
	xlarge: xlarge
};

const Icon = forwardRef((props, ref) => {
  const { layoutStyles, componentProps } = useLayoutPropsUtil(props);
  const {
    size = "medium",
    className,
    svg: Svg2,
    inherit,
    style,
    color,
    ...rest
  } = componentProps;
  const iconClassNames = cx([styles["icon"]], className, {
    [styles["small"]]: size === "small",
    [styles["medium"]]: size === "medium",
    [styles["large"]]: size === "large",
    [styles["xlarge"]]: size === "xlarge"
  });
  const styleCombined = {
    color: color ? color : inherit ? "inherit" : void 0,
    ...style,
    ...layoutStyles
  };
  return /* @__PURE__ */ jsx(
    "span",
    {
      className: iconClassNames,
      "data-anv": "icon",
      style: styleCombined,
      ref,
      ...rest,
      children: /* @__PURE__ */ jsx(Svg2, {})
    }
  );
});
Icon.displayName = "Icon";

export { Icon as I };
//# sourceMappingURL=Icon-BrdmZw1i-CG-LzgEz.js.map
