import { jsx } from 'react/jsx-runtime';
import { forwardRef } from 'react';
import { useTrackingId } from './useTrackingId.js';
import { c as childrenToString } from './childrenToString-Bz9MqbHb-Bz9MqbHb.js';
import { I as InputMask$1 } from './InputMask-DfpkWGmY-D8QEut94.js';

const InputMask = forwardRef(
  (props, ref) => {
    const inputProps = props.inputProps ?? {};
    const data = {
      label: "label" in inputProps ? childrenToString(inputProps.label) : null,
      labelProps: "labelProps" in inputProps ? inputProps.labelProps : null,
      prefix: childrenToString(inputProps.prefix),
      hint: "hint" in inputProps ? childrenToString(inputProps.hint) : null,
      description: "description" in inputProps ? childrenToString(inputProps.description) : null,
      size: inputProps.size,
      type: inputProps.type
    };
    const trackingId = useTrackingId({
      name: "InputMask",
      data,
      hasOverride: !!props["data-tracking-id"]
    });
    return /* @__PURE__ */ jsx(InputMask$1, { ref, "data-tracking-id": trackingId, ...props });
  }
);

export { InputMask as I };
//# sourceMappingURL=InputMask-CeqX68uX.js.map
