import { jsxs, jsx } from 'react/jsx-runtime';
import * as React from 'react';
import { forwardRef } from 'react';
import { c as cx } from './index-tZvMCc77.js';
import { I as Icon } from './Icon-BrdmZw1i-CG-LzgEz.js';
import { u as useLayoutPropsUtil } from './useLayoutPropsUtil-GT5myWCm-Clw_nEze.js';

import './Link-CVN5Mwtx.css';const SvgOpenInNew = (props) => /* @__PURE__ */ React.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", width: "1em", height: "1em", viewBox: "0 0 24 24", ...props }, /* @__PURE__ */ React.createElement("path", { d: "M18 19H6c-.55 0-1-.45-1-1V6c0-.55.45-1 1-1h5c.55 0 1-.45 1-1s-.45-1-1-1H5a2 2 0 0 0-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2v-6c0-.55-.45-1-1-1s-1 .45-1 1v5c0 .55-.45 1-1 1zM14 4c0 .55.45 1 1 1h2.59l-9.13 9.13a.996.996 0 1 0 1.41 1.41L19 6.41V9c0 .55.45 1 1 1s1-.45 1-1V4c0-.55-.45-1-1-1h-5c-.55 0-1 .45-1 1z" }));

const link = "_link_4o01j_2";
const secondary = "_secondary_4o01j_43";
const quiet = "_quiet_4o01j_52";
const styles = {
	link: link,
	"open-in-new": "_open-in-new_4o01j_27",
	secondary: secondary,
	quiet: quiet
};

const Link = forwardRef((props, ref) => {
  const { layoutStyles, componentProps } = useLayoutPropsUtil(props);
  const {
    children,
    className,
    appearance = "primary",
    quiet,
    style,
    ...rest
  } = componentProps;
  const linkClassNames = cx([styles["link"]], className, {
    [styles["quiet"]]: quiet,
    [styles["secondary"]]: appearance === "secondary"
  });
  const styleCombined = {
    ...style,
    ...layoutStyles
  };
  return /* @__PURE__ */ jsxs(
    "a",
    {
      className: linkClassNames,
      rel: "noopener noreferrer",
      "data-anv": "link",
      ref,
      style: styleCombined,
      ...rest,
      children: [
        children,
        rest.target === "_blank" && /* @__PURE__ */ jsx(Icon, { className: styles["open-in-new"], inherit: true, svg: SvgOpenInNew })
      ]
    }
  );
});
Link.displayName = "Link";
const useLinkStyles = (props) => {
  const { layoutStyles, componentProps } = useLayoutPropsUtil(props);
  const { className, appearance = "primary", quiet, style } = componentProps;
  const linkClassNames = cx([styles["link"]], className, {
    [styles["quiet"]]: quiet,
    [styles["secondary"]]: appearance === "secondary"
  });
  const styleCombined = Object.assign({}, style, layoutStyles);
  return { linkClassNames, styleCombined };
};

export { Link as L, useLinkStyles as u };
//# sourceMappingURL=Link-CVN5Mwtx-B08PO1ef.js.map
