import { jsx } from 'react/jsx-runtime';
import { forwardRef } from 'react';
import { useTrackingId } from './useTrackingId.js';
import { c as childrenToString } from './childrenToString-Bz9MqbHb-Bz9MqbHb.js';
import { L as Link$1 } from './Link-CVN5Mwtx-B08PO1ef.js';

const Link = forwardRef(
  (props, ref) => {
    const { onClick, pathname, children, search, ...rest } = props;
    const data = {
      appearance: props.appearance,
      quiet: props.quiet,
      children: childrenToString(children)
    };
    const handleClick = (...args) => {
      if (pathname) {
        const to = pathname + (search ?? "");
        args[0].preventDefault();
        history.pushState(null, "", to);
        onClick?.(...args);
      } else {
        onClick?.(...args);
      }
    };
    const trackingId = useTrackingId({
      name: "Link",
      data,
      hasOverride: !!rest["data-tracking-id"]
    });
    return /* @__PURE__ */ jsx(
      Link$1,
      {
        onClick: handleClick,
        ref,
        "data-tracking-id": trackingId,
        ...rest,
        children
      }
    );
  }
);
Link.displayName = "Link";

export { Link as L };
//# sourceMappingURL=Link-K3nk4QAp.js.map
