import { jsx } from 'react/jsx-runtime';
import { forwardRef } from 'react';
import { useTrackingId } from './useTrackingId.js';
import { L as ListboxOption$1, a as ListboxOptionGroup$1, b as Listbox$1 } from './Listbox-DLlT8qbJ-BvhkfmIf.js';

const ListboxElement = function(props, ref) {
  return /* @__PURE__ */ jsx(Listbox$1, { ref, ...props });
};
const ListboxOption = forwardRef(
  (props, ref) => {
    const data = {
      value: props.value,
      label: "item" in props ? props.item?.label : props.label
    };
    const trackingId = useTrackingId({
      name: "ListboxOption",
      data,
      hasOverride: !!props["data-tracking-id"]
    });
    return /* @__PURE__ */ jsx(ListboxOption$1, { ref, "data-tracking-id": trackingId, ...props });
  }
);
const ListboxOptionGroup = forwardRef(
  (props, ref) => {
    return /* @__PURE__ */ jsx(ListboxOptionGroup$1, { ref, ...props });
  }
);
const Listbox = Object.assign(
  forwardRef(ListboxElement),
  {
    Option: ListboxOption,
    OptionGroup: ListboxOptionGroup
  }
);

export { Listbox as L, ListboxOption as a, ListboxOptionGroup as b };
//# sourceMappingURL=Listbox-36Mda5DS.js.map
