import { jsx } from 'react/jsx-runtime';
import { forwardRef } from 'react';
import { useTrackingId } from './useTrackingId.js';
import { c as childrenToString } from './childrenToString-Bz9MqbHb-Bz9MqbHb.js';
import { O as OverflowText$1, a as Overflow$1 } from './Overflow-ENfRRD_5-DLHLZ02e.js';

const OverflowElement = forwardRef(
  (props, ref) => {
    const data = {
      children: childrenToString(props.children),
      height: props.height,
      truncate: props.truncate
    };
    const trackingId = useTrackingId({
      name: "Overflow",
      data,
      hasOverride: !!props["data-tracking-id"]
    });
    return /* @__PURE__ */ jsx(Overflow$1, { ref, "data-tracking-id": trackingId, ...props });
  }
);
const OverflowText = forwardRef(
  (props, ref) => {
    const data = {
      children: childrenToString(props.children),
      rows: props.rows,
      expandable: props.expandable,
      expandText: props.expandText,
      collapseText: props.collapseText
    };
    const trackingId = useTrackingId({
      name: "OverflowText",
      data,
      hasOverride: !!props["data-tracking-id"]
    });
    return /* @__PURE__ */ jsx(OverflowText$1, { ref, "data-tracking-id": trackingId, ...props });
  }
);
const Overflow = Object.assign(OverflowElement, {
  Text: OverflowText
});

export { Overflow as O, OverflowText as a };
//# sourceMappingURL=Overflow-vc1mxjUD.js.map
