import { jsx } from 'react/jsx-runtime';
import { forwardRef } from 'react';
import { useTrackingId } from './useTrackingId.js';
import { P as PopoverTrigger$1, a as PopoverContent$1, b as PopoverClose$1, c as PopoverButton$1, d as Popover$1 } from './Popover-CpyYXmal-I-E-B4u8.js';
import { c as childrenToString } from './childrenToString-Bz9MqbHb-Bz9MqbHb.js';

const PopoverElement = (props) => {
  return /* @__PURE__ */ jsx(Popover$1, { ...props });
};
function PopoverTrigger(props) {
  return /* @__PURE__ */ jsx(PopoverTrigger$1, { ...props });
}
const PopoverContent = forwardRef(
  (props, ref) => {
    return /* @__PURE__ */ jsx(PopoverContent$1, { ref, ...props });
  }
);
const PopoverClose = forwardRef(
  (props, ref) => {
    const data = {
      children: childrenToString(props.children)
    };
    const trackingId = useTrackingId({
      name: "PopoverClose",
      data,
      hasOverride: !!props["data-tracking-id"]
    });
    return /* @__PURE__ */ jsx(PopoverClose$1, { ref, "data-tracking-id": trackingId, ...props });
  }
);
const PopoverButton = forwardRef(
  (props, ref) => {
    const data = {
      children: childrenToString(props.children),
      appearance: props.appearance,
      icon: props.icon,
      size: props.size,
      type: props.type
    };
    const trackingId = useTrackingId({
      name: "PopoverButton",
      data,
      hasOverride: !!props["data-tracking-id"]
    });
    return /* @__PURE__ */ jsx(PopoverButton$1, { ref, "data-tracking-id": trackingId, ...props });
  }
);
const Popover = Object.assign(PopoverElement, {
  Trigger: PopoverTrigger,
  Content: PopoverContent,
  Close: PopoverClose,
  Button: PopoverButton
});

export { Popover as P, PopoverTrigger as a, PopoverContent as b, PopoverClose as c, PopoverButton as d };
//# sourceMappingURL=Popover-a81z9wSj.js.map
