import { jsx } from 'react/jsx-runtime';
import { forwardRef } from 'react';
import { useTrackingId } from './useTrackingId.js';
import { R as RadioGroup$1, a as Radio$1 } from './Radio-BlMDLvPw-DUeywcYR.js';
import { c as childrenToString } from './childrenToString-Bz9MqbHb-Bz9MqbHb.js';

const RadioElement = forwardRef(
  (props, ref) => {
    const data = {
      label: childrenToString(props.label),
      ariaLabel: props["aria-label"],
      ariaLabelledBy: props["aria-labelledby"],
      name: props.name,
      value: props.value
    };
    const trackingId = useTrackingId({
      name: "Radio",
      data,
      hasOverride: !!props["data-tracking-id"]
    });
    return /* @__PURE__ */ jsx(Radio$1, { ref, "data-tracking-id": trackingId, ...props });
  }
);
const RadioGroup = forwardRef(
  (props, ref) => {
    return /* @__PURE__ */ jsx(RadioGroup$1, { ref, ...props });
  }
);
const Radio = Object.assign(RadioElement, {
  Group: RadioGroup
});

export { Radio as R, RadioGroup as a };
//# sourceMappingURL=Radio-D3CqAXiM.js.map
