import { jsx, Fragment, jsxs } from 'react/jsx-runtime';
import { forwardRef, useContext, createContext, useRef, useId } from 'react';
import { c as cx } from './index-tZvMCc77.js';
import { m as motion } from './proxy-CreWmH-e.js';
import { u as useReducedMotion } from './use-reduced-motion-znCm41qB.js';
import { u as useOptionallyControlledState } from './useOptionallyControlledState-DAv5LXXh-DAv5LXXh.js';
import { u as useMergeRefs } from './useMergeRefs-Bde85AWI-Bde85AWI.js';
import { I as Icon } from './Icon-BrdmZw1i-CG-LzgEz.js';
import { D as Duration } from './primitive-BoyEHaOo.js';
import { useTrackingId } from './useTrackingId.js';

import './SegmentedControl.css';const legend = "_legend_1jy4v_3";
const children = "_children_1jy4v_4";
const segment = "_segment_1jy4v_2";
const fill = "_fill_1jy4v_80";
const small = "_small_1jy4v_83";
const medium = "_medium_1jy4v_92";
const styles = {
	"segmented-control": "_segmented-control_1jy4v_2",
	legend: legend,
	children: children,
	"select-indicator": "_select-indicator_1jy4v_5",
	segment: segment,
	fill: fill,
	small: small,
	"icon-only": "_icon-only_1jy4v_89",
	medium: medium
};

const SegmentedControlSegment$1 = forwardRef((props, ref) => {
  const { icon, value, children, className, ...rest } = props;
  const shouldReduceMotion = useReducedMotion();
  const { current, setCurrent, name } = useContext(SegmentedControlContext);
  const labelRef = useRef(null);
  const classNames = cx(styles.segment, className, {
    [styles["icon-only"]]: icon && !children
  });
  return /* @__PURE__ */ jsx(Fragment, { children: /* @__PURE__ */ jsxs(
    "label",
    {
      className: classNames,
      ref: useMergeRefs([labelRef, ref]),
      "data-anv": "segmented-control-segment",
      ...rest,
      children: [
        /* @__PURE__ */ jsx(
          "input",
          {
            type: "radio",
            name,
            value,
            onChange: () => setCurrent?.(value),
            checked: current === value,
            "aria-checked": current === value
          }
        ),
        icon ? /* @__PURE__ */ jsx(Icon, { svg: icon, "aria-hidden": true }) : null,
        children,
        current === value && /* @__PURE__ */ jsx(
          motion.span,
          {
            layoutId: name,
            className: styles["select-indicator"],
            transition: {
              duration: shouldReduceMotion ? 0 : +Duration.value.replace("ms", "") / 1e3
            }
          }
        )
      ]
    }
  ) });
});
SegmentedControlSegment$1.displayName = "SegmentedControlSegment";

const SegmentedControlContext = createContext({});
const SegmentedControlElement$1 = forwardRef((props, ref) => {
  const {
    className,
    onClick,
    onChange,
    children,
    size = "medium",
    defaultSelected,
    selected,
    name,
    fill,
    ...rest
  } = props;
  const [current, setCurrent] = useOptionallyControlledState({
    controlledValue: selected,
    defaultValue: defaultSelected,
    onChange
  });
  const segmentedControlRef = useRef(null);
  const SegmentedControlClassNames = cx(
    styles["segmented-control"],
    styles[size],
    className,
    {
      [styles.fill]: fill
    }
  );
  const uid = useId();
  return /* @__PURE__ */ jsx(
    motion.div,
    {
      transition: { duration: 0 },
      layout: true,
      role: "radiogroup",
      className: SegmentedControlClassNames,
      "data-anv": "segmented-control",
      ref: useMergeRefs([segmentedControlRef, ref]),
      ...rest,
      children: /* @__PURE__ */ jsx(
        SegmentedControlContext.Provider,
        {
          value: { current, setCurrent, name: name ?? uid },
          children
        }
      )
    }
  );
});
SegmentedControlElement$1.displayName = "SegmentedControl";
const SegmentedControl$1 = Object.assign(SegmentedControlElement$1, {
  Segment: SegmentedControlSegment$1
});

const SegmentedControlElement = forwardRef(
  (props, ref) => {
    const data = {
      name: props.name
    };
    const trackingId = useTrackingId({
      name: "SegmentedControl",
      data,
      hasOverride: !!props["data-tracking-id"]
    });
    return /* @__PURE__ */ jsx(
      SegmentedControl$1,
      {
        ref,
        "data-tracking-id": trackingId,
        ...props
      }
    );
  }
);
const SegmentedControlSegment = forwardRef(
  (props, ref) => {
    const data = {
      value: props.value
    };
    const trackingId = useTrackingId({
      name: "SegmentedControlSegment",
      data,
      hasOverride: !!props["data-tracking-id"]
    });
    return /* @__PURE__ */ jsx(
      SegmentedControlSegment$1,
      {
        ref,
        "data-tracking-id": trackingId,
        ...props
      }
    );
  }
);
const SegmentedControl = Object.assign(SegmentedControlElement, {
  Segment: SegmentedControlSegment
});

export { SegmentedControl as S, SegmentedControlSegment as a };
//# sourceMappingURL=SegmentedControl-D_ADGpVy.js.map
