import { jsxs, jsx } from 'react/jsx-runtime';
import { forwardRef, useState, useRef, useId, useEffect, useMemo, Children, useLayoutEffect, useContext, createContext, useCallback } from 'react';
import { c as cx } from './index-tZvMCc77.js';
import { S as SvgKeyboardArrowDown } from './keyboard_arrow_down-C8WQ38p1.js';
import { I as Icon } from './Icon-BrdmZw1i-CG-LzgEz.js';
import { u as useLayoutPropsUtil } from './useLayoutPropsUtil-GT5myWCm-Clw_nEze.js';
import { u as useMergeRefs } from './useMergeRefs-Bde85AWI-Bde85AWI.js';

import './SideNav.css';const sidenav = "_sidenav_hrmsy_110";
const root = "_root_hrmsy_111";
const group = "_group_hrmsy_115";
const hidden = "_hidden_hrmsy_177";
const arrow = "_arrow_hrmsy_184";
const styles = {
	sidenav: sidenav,
	root: root,
	"sidenav-group": "_sidenav-group_hrmsy_112",
	"sidenav-link": "_sidenav-link_hrmsy_113",
	"sidenav-collapsible": "_sidenav-collapsible_hrmsy_114",
	group: group,
	"group-label": "_group-label_hrmsy_128",
	hidden: hidden,
	arrow: arrow,
	"has-indicator": "_has-indicator_hrmsy_244"
};

const sideNavKeyboardNavigation = (e, links, current) => {
  const currentIndex = Array.prototype.indexOf.call(links, current.current);
  switch (e.key) {
    case "ArrowDown":
      if (!links) return;
      e.preventDefault();
      links[currentIndex].setAttribute("tabindex", "-1");
      if (currentIndex === links.length - 1) {
        links[0].setAttribute("tabindex", "0");
        links[0].focus();
        break;
      }
      links[currentIndex + 1].setAttribute("tabindex", "0");
      links[currentIndex + 1].focus();
      break;
    case "ArrowUp":
      e.preventDefault();
      if (!links) return;
      links[currentIndex].setAttribute("tabindex", "-1");
      if (currentIndex === 0) {
        links[links.length - 1].setAttribute("tabindex", "0");
        links[links.length - 1].focus();
        break;
      }
      links[currentIndex - 1].setAttribute("tabindex", "0");
      links[currentIndex - 1].focus();
      break;
  }
};

const SideNavLink$1 = forwardRef(
  (props, ref) => {
    const {
      className,
      children,
      href,
      id,
      active,
      onClick,
      onKeyDown,
      onKeyUp,
      style,
      disabled,
      ...rest
    } = props;
    const { links } = useSideNav();
    const linkRef = useRef(null);
    const { activeIds, addActiveId, removeActiveId } = useSideNav();
    useEffect(() => {
      if (!activeIds.has(id) && active) {
        addActiveId(id);
        return;
      }
      if (activeIds.has(id) && !active) {
        removeActiveId(id);
      }
    }, [active, activeIds]);
    function onKeyDownHandler(e) {
      sideNavKeyboardNavigation(e, links, linkRef);
      onKeyDown?.(e, id);
    }
    function onKeyUpHandler(e) {
      if (disabled) return;
      if (e.code === "Space" || e.code === "Enter") {
        e.preventDefault();
        onClick && e.currentTarget.click();
      }
      onKeyUp?.(e, id);
    }
    function onClickHandler(e) {
      if (disabled) {
        e.preventDefault();
        return;
      }
      const current = Array.prototype.slice.call(links).filter((child) => child.tabIndex === 0)[0];
      if (current) current.setAttribute("tabindex", "-1");
      linkRef.current?.setAttribute("tabindex", "0");
      linkRef.current?.focus();
      onClick?.(e, id);
    }
    return /* @__PURE__ */ jsx("li", { className, "data-anv": "sidenav-link", style, ref, children: /* @__PURE__ */ jsx(
      "a",
      {
        className: styles["sidenav-link"],
        "aria-current": active ? "page" : void 0,
        href,
        ref: linkRef,
        onClick: onClickHandler,
        onKeyDown: onKeyDownHandler,
        onKeyUp: onKeyUpHandler,
        id,
        "aria-disabled": disabled,
        tabIndex: active ? 0 : -1,
        ...rest,
        children
      }
    ) });
  }
);
SideNavLink$1.displayName = "SideNavLink";

const SideNavCollapsible$1 = forwardRef((props, ref) => {
  const {
    className,
    children,
    label,
    onClick,
    onKeyDown,
    defaultExpanded = false,
    expanded: expandedControlled,
    ...rest
  } = props;
  const [expanded, setExpanded] = useState(defaultExpanded);
  const [hasSelected, setHasSelected] = useState(false);
  const sideNavGroupLabelRef = useRef(null);
  const groupRef = useRef(null);
  const sideNavGroupClassNames = cx(styles["sidenav-collapsible"], className);
  const { links, reCalculateLinks } = useSideNav();
  const groupId = useId();
  const setExpandedUncontrolled = (newState) => {
    if (expandedControlled === void 0)
      setExpanded((prev) => {
        if (newState !== void 0) return newState;
        return !prev;
      });
  };
  useEffect(() => {
    expandedControlled !== void 0 && setExpanded(expandedControlled);
  }, [expandedControlled]);
  const { activeIds } = useSideNav();
  const childIds = useMemo(
    () => Children.map(children, (child) => child.props)?.map(
      (item) => item.id
    ) || [],
    [Children]
  );
  function handleOnClick(e) {
    setExpandedUncontrolled();
    setTimeout(() => reCalculateLinks(), 0);
    const current = Array.prototype.slice.call(links).filter((child) => child.tabIndex === 0)[0];
    if (current) current.setAttribute("tabindex", "-1");
    sideNavGroupLabelRef.current?.setAttribute("tabindex", "0");
    sideNavGroupLabelRef.current?.focus();
    onClick?.(e);
  }
  function handleKeyDown(e) {
    sideNavKeyboardNavigation(e, links, sideNavGroupLabelRef);
    switch (e.key) {
      case "ArrowRight":
        setExpanded(true);
        setTimeout(() => reCalculateLinks(), 0);
        break;
      case "ArrowLeft":
        setExpanded(false);
        setTimeout(() => reCalculateLinks(), 0);
        break;
    }
    onKeyDown?.(e);
  }
  useLayoutEffect(() => {
    const hasActiveChildren = childIds.some((id) => activeIds.has(id));
    if (hasActiveChildren) {
      setExpandedUncontrolled(true);
      setHasSelected(true);
      setTimeout(() => {
        const selectedChild = groupRef.current?.querySelector(`[active='true']`);
        selectedChild?.setAttribute("tabindex", "0");
        reCalculateLinks();
      }, 0);
    }
  }, []);
  useEffect(() => {
    if (!activeIds.size || !childIds.some((id) => activeIds.has(id))) {
      setHasSelected(false);
      return;
    }
    setHasSelected(true);
  }, [activeIds]);
  return /* @__PURE__ */ jsxs(
    "li",
    {
      ref,
      "data-anv": "sidenav-collapsible",
      ...rest,
      className: sideNavGroupClassNames,
      children: [
        /* @__PURE__ */ jsxs(
          "button",
          {
            "aria-expanded": expanded,
            "aria-controls": groupId,
            type: "button",
            tabIndex: -1,
            onClick: handleOnClick,
            ref: sideNavGroupLabelRef,
            className: cx(styles["sidenav-link"], {
              [styles["has-indicator"]]: hasSelected && !expanded
            }),
            onKeyDown: handleKeyDown,
            children: [
              label,
              /* @__PURE__ */ jsx(Icon, { className: styles["arrow"], inherit: true, svg: SvgKeyboardArrowDown, "aria-hidden": true })
            ]
          }
        ),
        /* @__PURE__ */ jsx(
          "ul",
          {
            id: groupId,
            ref: groupRef,
            className: cx(styles["group"], !expanded && styles.hidden),
            children
          }
        )
      ]
    }
  );
});
SideNavCollapsible$1.displayName = "SideNavCollapsible";

const SideNavGroup$1 = forwardRef(
  (props, ref) => {
    const { children, label, ...rest } = props;
    const sideNavGroupClassNames = cx(styles["sidenav-group"]);
    const groupLabelId = useId();
    return /* @__PURE__ */ jsxs("li", { ref, "data-anv": "sidenav-group", ...rest, children: [
      /* @__PURE__ */ jsx("label", { id: groupLabelId, className: styles["group-label"], children: label }),
      /* @__PURE__ */ jsx("ul", { "aria-labelledby": groupLabelId, className: sideNavGroupClassNames, children })
    ] });
  }
);
SideNavGroup$1.displayName = "SideNavGroup";

const SideNavContext$1 = createContext(null);
const SideNavElement$1 = forwardRef((props, ref) => {
  const { layoutStyles, componentProps } = useLayoutPropsUtil(props);
  const [activeIds, setActiveIds] = useState(/* @__PURE__ */ new Set());
  const { className, children, style, ...rest } = componentProps;
  const addActiveId = (id) => {
    if (activeIds.has(id)) return;
    const newIds = new Set(activeIds);
    newIds.add(id);
    setActiveIds(newIds);
  };
  const removeActiveId = (id) => {
    if (!activeIds.has(id)) return;
    const newIds = new Set(activeIds);
    newIds.delete(id);
    setActiveIds(newIds);
  };
  const sideNavRef = useRef(null);
  const [links, setLinks] = useState();
  const styleCombined = {
    ...style,
    ...layoutStyles
  };
  function reCalculateLinks() {
    if (sideNavRef.current) {
      const items = sideNavRef.current.querySelectorAll(
        "li[data-anv='sidenav-link'] a:not([aria-disabled='true']), li[data-anv='sidenav-collapsible'] button[aria-expanded]:not([aria-disabled='true'])"
      );
      setLinks(items);
    }
  }
  useEffect(() => {
    reCalculateLinks();
  }, []);
  const sidenavClassNames = cx([styles["sidenav"]], className);
  const value = useMemo(
    () => ({
      links,
      reCalculateLinks,
      activeIds,
      addActiveId,
      removeActiveId
    }),
    [links, activeIds, addActiveId, removeActiveId, reCalculateLinks]
  );
  return /* @__PURE__ */ jsx(SideNavContext$1.Provider, { value, children: /* @__PURE__ */ jsx(
    "nav",
    {
      ref: useMergeRefs([sideNavRef, ref]),
      className: sidenavClassNames,
      style: styleCombined,
      "data-anv": "sidenav",
      ...rest,
      children: /* @__PURE__ */ jsx("ul", { className: styles["root"], children })
    }
  ) });
});
const useSideNav = () => {
  const context = useContext(SideNavContext$1);
  if (context == null) {
    throw new Error("useSideNav must be wrapped in <SideNav />");
  }
  return context;
};
SideNavElement$1.displayName = "SideNav";
const SideNav$1 = Object.assign(SideNavElement$1, {
  Link: SideNavLink$1,
  Collapsible: SideNavCollapsible$1,
  Group: SideNavGroup$1
});

const defaultContext = {
  location: "",
  // eslint-disable-next-line @typescript-eslint/no-unused-vars, @typescript-eslint/no-empty-function
  setLocation: (_location) => {
  }
};
const SideNavContext = createContext(defaultContext);
const useSideNavContext = () => useContext(SideNavContext);
const SideNavProvider = ({ children }) => {
  const [location, setLocation] = useState(window.location.pathname);
  const sideNavContext = {
    location,
    setLocation
  };
  return /* @__PURE__ */ jsx(SideNavContext.Provider, { value: sideNavContext, children });
};

const SideNavElement = forwardRef(
  (props, ref) => {
    return /* @__PURE__ */ jsx(SideNavProvider, { children: /* @__PURE__ */ jsx(SideNav$1, { ref, ...props }) });
  }
);
SideNavElement.displayName = "SideNavElement";
const SideNavCollapsible = forwardRef(
  (props, ref) => {
    return /* @__PURE__ */ jsx(SideNavCollapsible$1, { ref, ...props });
  }
);
SideNavCollapsible.displayName = "SideNavCollapsible";
const SideNavGroup = forwardRef(
  (props, ref) => {
    return /* @__PURE__ */ jsx(SideNavGroup$1, { ref, ...props });
  }
);
SideNavGroup.displayName = "SideNavGroup";
const SideNavLinkWithRouting = forwardRef(
  ({ href, pathname, search, onClick, ...rest }, ref) => {
    const { location, setLocation } = useSideNavContext();
    const to = pathname + (search ?? "");
    const handleClick = useCallback(
      (...args) => {
        args[0].preventDefault();
        history.pushState(null, "", to);
        setLocation(to);
        return onClick?.(...args);
      },
      [onClick, to, setLocation]
    );
    return /* @__PURE__ */ jsx(
      SideNavLink$1,
      {
        href: pathname != null ? to : href,
        active: pathname === location,
        onClick: pathname != null ? handleClick : onClick,
        ref,
        ...rest
      }
    );
  }
);
SideNavLinkWithRouting.displayName = "SideNavLinkWithRouting";
const SideNavLink = forwardRef(
  (rest, ref) => {
    if ("pathname" in rest) {
      return /* @__PURE__ */ jsx(SideNavLinkWithRouting, { ref, ...rest });
    } else {
      return /* @__PURE__ */ jsx(SideNavLink$1, { ref, ...rest });
    }
  }
);
SideNavLink.displayName = "SideNavLink";
const SideNav = Object.assign(SideNavElement, {
  Link: SideNavLink,
  Collapsible: SideNavCollapsible,
  Group: SideNavGroup
});

export { SideNav as S, SideNavCollapsible as a, SideNavGroup as b, SideNavLink as c };
//# sourceMappingURL=SideNav-C7wc1_JK.js.map
