import { jsxs, jsx, Fragment } from 'react/jsx-runtime';
import { forwardRef, useContext, createContext, useRef, useState, useEffect, useMemo } from 'react';
import { useTrackingId } from './useTrackingId.js';
import { c as cx } from './index-tZvMCc77.js';
import { a as Overflow } from './Overflow-ENfRRD_5-DLHLZ02e.js';
import { m as motion } from './proxy-CreWmH-e.js';
import { e as DurationSlow } from './primitive-BoyEHaOo.js';
import { u as useLayoutPropsUtil } from './useLayoutPropsUtil-GT5myWCm-Clw_nEze.js';
import { B as Button } from './Button-C-QpfgfF-CRBE7KiD.js';
import { u as useMergeRefs } from './useMergeRefs-Bde85AWI-Bde85AWI.js';
import { I as Icon } from './Icon-BrdmZw1i-CG-LzgEz.js';
import { S as SvgCheck } from './check-Cf67OWrZ.js';

import './Stepper.css';const bar = "_bar_txl4u_26";
const label$1 = "_label_txl4u_42";
const circle = "_circle_txl4u_49";
const styles$3 = {
	"stepper-step": "_stepper-step_txl4u_2",
	bar: bar,
	label: label$1,
	circle: circle,
	"all-completed": "_all-completed_txl4u_80",
	"can-navigate": "_can-navigate_txl4u_83"
};

const StepperStep$1 = forwardRef(
  (props, ref) => {
    const stepRef = useRef(null);
    const {
      current,
      items,
      setCurrent,
      focus,
      setFocus,
      allCompleted,
      allowNavigateToPrevStep
    } = useContext(StepperContext);
    const {
      onClick,
      children,
      onFocus,
      onKeyDown,
      controls,
      className,
      ...rest
    } = props;
    const index = useRef();
    const [selected, setSelected] = useState(false);
    const [completed, setCompleted] = useState(
      // Below is to be used for custom overriding
      // completed state for a step
      // Check Stepper.stories.tsx#103 for the use case
      stepRef.current?.getAttribute("data-completed") === "true" ? true : void 0
    );
    useEffect(() => {
      if (!items) return;
      index.current = Array.prototype.indexOf.call(items, stepRef.current);
      setCompleted(index.current < current);
      setSelected(index.current === current);
    }, [current, items]);
    const stepClassNames = cx(styles$3["stepper-step"], className, {
      [styles$3["can-navigate"]]: allowNavigateToPrevStep,
      [styles$3["all-completed"]]: allCompleted
    });
    const onClickHandler = (e) => {
      onClick?.(e, index.current);
      if (!allowNavigateToPrevStep || selected || index.current === void 0 || !items || index.current > current) {
        return;
      }
      setCurrent(index.current ?? 0);
      setFocus(index.current);
      items[index.current].focus();
    };
    const onKeyDownHandler = (e) => {
      onKeyDown?.(e);
      const focusableItems = Array.prototype.filter.call(
        items,
        (item) => item.getAttribute("data-completed") === "true" || item.getAttribute("aria-selected") === "true"
      );
      const prevFocus = focus - 1;
      const nextFocus = focus + 1;
      switch (e.code) {
        case "Enter":
        case "Space":
          e.preventDefault();
          setCurrent(focus);
          break;
        case "ArrowRight":
          e.preventDefault();
          if (nextFocus === focusableItems.length) {
            setFocus(0);
            focusableItems[0].focus();
            focusableItems[0].setAttribute("tabindex", "0");
            stepRef.current?.setAttribute("tabindex", "-1");
            return;
          }
          stepRef.current?.setAttribute("tabindex", "-1");
          setFocus(nextFocus);
          focusableItems[nextFocus].focus();
          focusableItems[nextFocus].setAttribute("tabindex", "0");
          break;
        case "ArrowLeft":
          e.preventDefault();
          if (focus === 0) {
            const lastItemIndex = focusableItems.length - 1;
            setFocus(lastItemIndex);
            focusableItems[lastItemIndex].focus();
            focusableItems[lastItemIndex].setAttribute("tabindex", "0");
            stepRef.current?.setAttribute("tabindex", "-1");
            return;
          }
          stepRef.current?.setAttribute("tabindex", "-1");
          setFocus(prevFocus);
          focusableItems[prevFocus].focus();
          focusableItems[prevFocus].setAttribute("tabindex", "0");
          break;
      }
    };
    return /* @__PURE__ */ jsxs(
      "button",
      {
        type: "button",
        role: "tab",
        "data-anv": "stepper-step",
        className: stepClassNames,
        "aria-selected": selected,
        "aria-controls": controls,
        tabIndex: allowNavigateToPrevStep && selected ? 0 : -1,
        "data-completed": completed,
        onClick: onClickHandler,
        onKeyDown: allowNavigateToPrevStep ? onKeyDownHandler : onKeyDown,
        ...rest,
        ref: useMergeRefs([stepRef, ref]),
        children: [
          /* @__PURE__ */ jsx("span", { className: styles$3.bar }),
          /* @__PURE__ */ jsxs("span", { className: styles$3.label, children: [
            /* @__PURE__ */ jsx("span", { className: styles$3.circle, children: /* @__PURE__ */ jsx(Icon, { svg: SvgCheck, inherit: true, "aria-hidden": true }) }),
            children
          ] })
        ]
      }
    );
  }
);
StepperStep$1.displayName = "StepperStep";

const label = "_label_qeq4d_33";
const styles$2 = {
	"stepper-list": "_stepper-list_qeq4d_2",
	"stepper-steps": "_stepper-steps_qeq4d_24",
	label: label
};

const StepperList$1 = forwardRef(
  (props, ref) => {
    const { className, children, onKeyDown, ...rest } = props;
    const { current, items } = useContext(StepperContext);
    const tabListClassNames = cx(styles$2["stepper-list"], className);
    const currentLabel = items?.[current].querySelectorAll("span")[1].textContent;
    return /* @__PURE__ */ jsxs(
      "div",
      {
        ...rest,
        className: tabListClassNames,
        "data-anv": "stepper-list",
        ref,
        role: "tablist",
        children: [
          /* @__PURE__ */ jsx("div", { className: styles$2["stepper-steps"], children }),
          /* @__PURE__ */ jsx("span", { className: styles$2.label, children: currentLabel })
        ]
      }
    );
  }
);
StepperList$1.displayName = "StepperList";

const styles$1 = {
	"stepper-panel": "_stepper-panel_4h550_2"
};

const StepperPanel$1 = forwardRef(
  (props, ref) => {
    const { layoutStyles, componentProps } = useLayoutPropsUtil(props);
    const { id, className, style, children, ...rest } = componentProps;
    const { current, items, allCompleted, setCurrentId } = useContext(StepperContext);
    const currentId = items?.[current].getAttribute("aria-controls");
    const isCurrent = currentId === id;
    useEffect(() => {
      if (isCurrent && !allCompleted) {
        setCurrentId(currentId ?? "");
      }
    }, [allCompleted, isCurrent, currentId, setCurrentId]);
    const tabPanelClassNames = cx(styles$1["stepper-panel"], className);
    const styleCombined = {
      ...style,
      ...layoutStyles
    };
    if (isCurrent && !allCompleted) {
      return /* @__PURE__ */ jsx(
        motion.div,
        {
          style: styleCombined,
          className: tabPanelClassNames,
          transition: {
            opacity: {
              duration: +DurationSlow.value.replace("ms", "") / 1e3
            }
          },
          initial: { opacity: 0 },
          animate: { opacity: 1 },
          exit: { opacity: 0 },
          layout: true,
          ...rest,
          role: "tabpanel",
          "data-anv": "stepper-panel",
          id,
          ref,
          children: /* @__PURE__ */ jsx(Overflow, { flexGrow: 1, children })
        }
      );
    }
    return /* @__PURE__ */ jsx(Fragment, {});
  }
);
StepperPanel$1.displayName = "StepperPanel";

const stepper = "_stepper_1czb4_2";
const styles = {
	stepper: stepper
};

const StepperNextButton$1 = forwardRef((props, ref) => {
  const {
    setAllCompleted,
    onComplete,
    setCurrent,
    setFocus,
    items,
    current,
    allCompleted
  } = useContext(StepperContext);
  const {
    onClick,
    onFocus,
    nextLabel = "Next",
    completeLabel = "Complete",
    appearance = "primary",
    ...rest
  } = props;
  const proceedToNextStep = () => {
    if (items && current === items.length - 1) {
      items.forEach((item) => item.setAttribute("tabindex", "-1"));
      setAllCompleted?.(true);
      onComplete?.();
      return;
    }
    setCurrent(current + 1);
    setFocus(current + 1);
  };
  const onClickHandler = (e) => {
    const onClickResult = onClick?.(e);
    if (onClickResult !== void 0 && !!onClickResult && onClickResult instanceof Promise) {
      onClickResult.then((result) => {
        if (result === false) return;
        proceedToNextStep();
      });
    } else {
      if (onClickResult === false) return;
      proceedToNextStep();
    }
  };
  return allCompleted ? null : /* @__PURE__ */ jsx(
    Button,
    {
      "data-anv": "stepper-next-button",
      onClick: onClickHandler,
      appearance,
      ref,
      ...rest,
      children: items && current === items.length - 1 ? completeLabel : nextLabel
    }
  );
});
StepperNextButton$1.displayName = "StepperNextButton";

const StepperPrevButton$1 = forwardRef((props, ref) => {
  const {
    setCurrent,
    setFocus,
    allCompleted,
    setAllCompleted,
    items,
    current,
    allowNavigateToPrevStep
  } = useContext(StepperContext);
  const { onClick, label = "Previous", onFocus, ...rest } = props;
  const onClickHandler = (e) => {
    if (allCompleted) {
      setAllCompleted?.(false);
      allowNavigateToPrevStep && items?.[current].setAttribute("tabindex", "0");
    } else {
      setCurrent(current - 1);
      setFocus(current - 1);
    }
    onClick?.(e);
  };
  return current === 0 ? null : /* @__PURE__ */ jsx(
    Button,
    {
      "data-anv": "stepper-prev-button",
      onClick: onClickHandler,
      ref,
      ...rest,
      children: label
    }
  );
});
StepperPrevButton$1.displayName = "StepperPrevButton";

const StepperFinalPanel$1 = forwardRef((props, ref) => {
  const { layoutStyles, componentProps } = useLayoutPropsUtil(props);
  const { id, className, style, children, ...rest } = componentProps;
  const { allCompleted, setCurrentId } = useContext(StepperContext);
  useEffect(() => {
    if (allCompleted) {
      setCurrentId("final-panel");
    }
  }, [allCompleted, setCurrentId]);
  const tabPanelClassNames = cx(styles$1["stepper-panel"], className);
  const styleCombined = {
    ...style,
    ...layoutStyles
  };
  if (allCompleted) {
    return /* @__PURE__ */ jsx(
      motion.div,
      {
        style: styleCombined,
        className: tabPanelClassNames,
        transition: {
          opacity: {
            duration: +DurationSlow.value.replace("ms", "") / 1e3
          }
        },
        initial: { opacity: 0 },
        animate: { opacity: 1 },
        exit: { opacity: 0 },
        layout: true,
        ...rest,
        role: "tabpanel",
        "data-anv": "stepper-final-panel",
        tabIndex: 0,
        ref,
        children: /* @__PURE__ */ jsx(Overflow, { children })
      }
    );
  }
  return null;
});
StepperFinalPanel$1.displayName = "StepperFinalPanel";

const StepperContext = createContext({
  current: 0,
  currentId: "",
  focus: 0,
  setFocus: () => void 0,
  setCurrent: () => void 0,
  setCurrentId: () => void 0
});
const StepperElement$1 = forwardRef(
  (props, ref) => {
    const { layoutStyles, componentProps } = useLayoutPropsUtil(props);
    const {
      defaultIndex,
      className,
      allowNavigateToPrevStep,
      children,
      onChange,
      onComplete,
      style,
      ...rest
    } = componentProps;
    const tabRef = useRef(null);
    const [items, setItems] = useState();
    const [allCompleted, setAllCompleted] = useState(false);
    const [current, setCurrent] = useState(defaultIndex ?? 0);
    const [currentId, setCurrentId] = useState("");
    const [focus, setFocus] = useState(defaultIndex ?? 0);
    const stepperClassNames = cx(styles["stepper"], className);
    useEffect(() => {
      setItems(tabRef.current?.querySelectorAll("[role=tab]:not([disabled])"));
    }, []);
    useEffect(() => {
      onChange?.({
        currentStepId: currentId,
        currentStepIndex: allCompleted ? void 0 : current
      });
    }, [allCompleted, currentId, onChange]);
    const styleCombined = { ...style, ...layoutStyles };
    const value = useMemo(
      () => ({
        current,
        setCurrent,
        currentId,
        setCurrentId,
        focus,
        setFocus,
        onComplete,
        items,
        allCompleted,
        setAllCompleted,
        allowNavigateToPrevStep
      }),
      [
        current,
        currentId,
        focus,
        onComplete,
        items,
        allCompleted,
        setAllCompleted,
        allowNavigateToPrevStep
      ]
    );
    return /* @__PURE__ */ jsx(StepperContext.Provider, { value, children: /* @__PURE__ */ jsx(
      motion.div,
      {
        transition: { duration: 0 },
        layout: true,
        className: stepperClassNames,
        "data-anv": "stepper",
        style: styleCombined,
        ...rest,
        ref: useMergeRefs([tabRef, ref]),
        children
      }
    ) });
  }
);
StepperElement$1.displayName = "Stepper";
const Stepper$1 = Object.assign(StepperElement$1, {
  Step: StepperStep$1,
  List: StepperList$1,
  Panel: StepperPanel$1,
  NextButton: StepperNextButton$1,
  PrevButton: StepperPrevButton$1,
  FinalPanel: StepperFinalPanel$1
});

const StepperElement = forwardRef(
  (props, ref) => {
    return /* @__PURE__ */ jsx(Stepper$1, { ref, ...props });
  }
);
const StepperList = forwardRef(
  (props, ref) => {
    return /* @__PURE__ */ jsx(StepperList$1, { ref, ...props });
  }
);
const StepperStep = forwardRef(
  (props, ref) => {
    return /* @__PURE__ */ jsx(StepperStep$1, { ref, ...props });
  }
);
const StepperPanel = forwardRef(
  (props, ref) => {
    return /* @__PURE__ */ jsx(StepperPanel$1, { ref, ...props });
  }
);
const StepperFinalPanel = forwardRef(
  (props, ref) => {
    return /* @__PURE__ */ jsx(StepperFinalPanel$1, { ref, ...props });
  }
);
const StepperNextButton = forwardRef(
  (props, ref) => {
    const data = {
      nextLabel: props.nextLabel,
      completeLabel: props.completeLabel
    };
    const trackingId = useTrackingId({
      name: "StepperNextButton",
      data,
      hasOverride: !!props["data-tracking-id"]
    });
    return /* @__PURE__ */ jsx(
      StepperNextButton$1,
      {
        ref,
        "data-tracking-id": trackingId,
        ...props
      }
    );
  }
);
const StepperPrevButton = forwardRef(
  (props, ref) => {
    const data = {
      label: props.label
    };
    const trackingId = useTrackingId({
      name: "StepperPrevButton",
      data,
      hasOverride: !!props["data-tracking-id"]
    });
    return /* @__PURE__ */ jsx(
      StepperPrevButton$1,
      {
        ref,
        "data-tracking-id": trackingId,
        ...props
      }
    );
  }
);
const Stepper = Object.assign(StepperElement, {
  List: StepperList,
  Step: StepperStep,
  Panel: StepperPanel,
  FinalPanel: StepperFinalPanel,
  NextButton: StepperNextButton,
  PrevButton: StepperPrevButton
});

export { Stepper as S, StepperList as a, StepperStep as b, StepperPanel as c, StepperFinalPanel as d, StepperNextButton as e, StepperPrevButton as f };
//# sourceMappingURL=Stepper-Bp0w8eRW.js.map
