import { jsxs, jsx } from 'react/jsx-runtime';
import { forwardRef } from 'react';
import { useTrackingId } from './useTrackingId.js';
import { c as childrenToString } from './childrenToString-Bz9MqbHb-Bz9MqbHb.js';
import { c as cx } from './index-tZvMCc77.js';
import { I as Icon } from './Icon-BrdmZw1i-CG-LzgEz.js';
import { S as SvgCheck } from './check-Cf67OWrZ.js';
import { u as useLayoutPropsUtil } from './useLayoutPropsUtil-GT5myWCm-Clw_nEze.js';

import './Switch.css';const toggle = "_toggle_z38tb_24";
const indicator = "_indicator_z38tb_38";
const check = "_check_z38tb_52";
const styles = {
	"switch": "_switch_z38tb_2",
	toggle: toggle,
	indicator: indicator,
	check: check
};

const Switch$1 = forwardRef(
  (props, ref) => {
    const { layoutStyles, componentProps } = useLayoutPropsUtil(props);
    const {
      className,
      onChange,
      checked,
      defaultChecked,
      value,
      style,
      ...rest
    } = componentProps;
    const onChangeHandler = (e) => {
      onChange?.(e, { value, checked: e.target.checked });
    };
    const switchClassNames = cx(styles["switch"], className);
    const styleCombined = {
      ...style,
      ...layoutStyles
    };
    return /* @__PURE__ */ jsxs("label", { className: switchClassNames, style: styleCombined, children: [
      /* @__PURE__ */ jsx(
        "input",
        {
          "data-anv": "switch",
          ref,
          type: "checkbox",
          role: "switch",
          value,
          "aria-checked": checked ?? defaultChecked,
          checked,
          defaultChecked,
          onChange: onChangeHandler,
          ...rest
        }
      ),
      /* @__PURE__ */ jsx("span", { "aria-hidden": true, className: styles["toggle"], children: /* @__PURE__ */ jsx("span", { className: styles["indicator"], children: /* @__PURE__ */ jsx(Icon, { svg: SvgCheck, className: styles["check"] }) }) }),
      "label" in props && props.label
    ] });
  }
);
Switch$1.displayName = "Switch";

const Switch = forwardRef(
  (props, ref) => {
    const data = {
      label: childrenToString(props.label),
      ariaLabel: props["aria-label"],
      ariaLabelledBy: props["aria-labelledby"],
      value: props.value
    };
    const trackingId = useTrackingId({
      name: "Switch",
      data,
      hasOverride: !!props["data-tracking-id"]
    });
    return /* @__PURE__ */ jsx(Switch$1, { ref, "data-tracking-id": trackingId, ...props });
  }
);

export { Switch as S };
//# sourceMappingURL=Switch-BbHIwrGc.js.map
