import { jsx } from 'react/jsx-runtime';
import { c as cx } from './index-tZvMCc77.js';
import { forwardRef } from 'react';
import { u as useLayoutPropsUtil } from './useLayoutPropsUtil-GT5myWCm-Clw_nEze.js';

import './Text-CN_-FF7J.css';const headline = "_headline_er6pr_2";
const eyebrow = "_eyebrow_er6pr_15";
const bodytext = "_bodytext_er6pr_28";
const xlarge = "_xlarge_er6pr_73";
const large = "_large_er6pr_77";
const medium = "_medium_er6pr_81";
const small = "_small_er6pr_84";
const subdued = "_subdued_er6pr_102";
const inline = "_inline_er6pr_105";
const styles = {
	headline: headline,
	eyebrow: eyebrow,
	bodytext: bodytext,
	xlarge: xlarge,
	large: large,
	medium: medium,
	small: small,
	subdued: subdued,
	inline: inline
};

const Text = forwardRef((props, ref) => {
  const { layoutStyles, componentProps } = useLayoutPropsUtil(props);
  if (props.variant === "headline") {
    const {
      variant: _,
      children,
      className,
      el: HeadlineElement,
      size = "medium",
      style,
      ...rest
    } = componentProps;
    const TextClasses = cx(styles["headline"], className, {
      [styles[`${size}`]]: size
    });
    const styleCombined = { ...style, ...layoutStyles };
    return (
      // @ts-expect-error ts(2604) HeadlineElement will work as element tag
      /* @__PURE__ */ jsx(
        HeadlineElement,
        {
          ref,
          className: TextClasses,
          "data-anv": "text",
          style: styleCombined,
          ...rest,
          children
        }
      )
    );
  } else if (props.variant === "eyebrow") {
    const {
      variant: _,
      children,
      className,
      size = "medium",
      style,
      ...rest
    } = componentProps;
    const TextClasses = cx(styles["eyebrow"], className, {
      [styles[`${size}`]]: size
    });
    const styleCombined = { ...style, ...layoutStyles };
    return /* @__PURE__ */ jsx(
      "span",
      {
        ref,
        className: TextClasses,
        "data-anv": "text",
        style: styleCombined,
        ...rest,
        children
      }
    );
  } else {
    const {
      variant: _,
      children,
      className,
      subdued,
      inline,
      style,
      size = "medium",
      ...rest
    } = componentProps;
    const TextClasses = cx(styles["bodytext"], className, {
      [styles[`${size}`]]: size,
      [styles["subdued"]]: subdued,
      [styles["inline"]]: inline
    });
    const styleCombined = { ...style, ...layoutStyles };
    if (inline) {
      return /* @__PURE__ */ jsx(
        "span",
        {
          ref,
          className: TextClasses,
          "data-anv": "text",
          style: styleCombined,
          ...rest,
          children
        }
      );
    } else {
      return /* @__PURE__ */ jsx(
        "p",
        {
          ref,
          className: TextClasses,
          "data-anv": "text",
          style: styleCombined,
          ...rest,
          children
        }
      );
    }
  }
});
Text.displayName = "Text";

export { Text as T };
//# sourceMappingURL=Text-CN_-FF7J-Dzoy8A70.js.map
