import { jsx } from 'react/jsx-runtime';
import { forwardRef } from 'react';
import { useTrackingId } from './useTrackingId.js';
import { c as childrenToString } from './childrenToString-Bz9MqbHb-Bz9MqbHb.js';
import { T as TextField$1 } from './TextField-Bp1q4hMI-2jGZG2k2.js';

const TextField = forwardRef(
  (props, ref) => {
    const data = {
      label: childrenToString(props.label),
      labelProps: props.labelProps,
      prefix: childrenToString(props.prefix),
      hint: childrenToString(props.hint),
      description: childrenToString(props.description),
      size: props.size,
      type: props.type
    };
    const trackingId = useTrackingId({
      name: "TextField",
      data,
      hasOverride: !!props["data-tracking-id"]
    });
    return /* @__PURE__ */ jsx(TextField$1, { ref, "data-tracking-id": trackingId, ...props });
  }
);

export { TextField as T };
//# sourceMappingURL=TextField-Ds9EKvSs.js.map
