import { jsx } from 'react/jsx-runtime';
import { forwardRef } from 'react';
import { useTrackingId } from './useTrackingId.js';
import { c as childrenToString } from './childrenToString-Bz9MqbHb-Bz9MqbHb.js';
import { T as TooltipTrigger$1, e as TooltipContent$1, f as Tooltip$1 } from './ProgressBar-CeClhdcf-Dcft7ZjO.js';

const TooltipElement = (props) => {
  return /* @__PURE__ */ jsx(Tooltip$1, { ...props });
};
const TooltipTrigger = forwardRef(
  (props, ref) => {
    const data = {
      children: childrenToString(props.children)
    };
    const trackingId = useTrackingId({
      name: "TooltipTrigger",
      data,
      hasOverride: !!props["data-tracking-id"]
    });
    return /* @__PURE__ */ jsx(TooltipTrigger$1, { ref, "data-tracking-id": trackingId, ...props });
  }
);
const TooltipContent = forwardRef(
  (props, ref) => {
    return /* @__PURE__ */ jsx(TooltipContent$1, { ref, ...props });
  }
);
const Tooltip = Object.assign(TooltipElement, {
  Trigger: TooltipTrigger,
  Content: TooltipContent
});

export { Tooltip as T, TooltipTrigger as a, TooltipContent as b };
//# sourceMappingURL=Tooltip-C-UNrFz3.js.map
