import { ComboboxProps as CoreComboboxProps, ComboboxSelectProps as CoreComboboxSelectProps, ComboboxContentProps as CoreComboboxContentProps, ComboboxSearchFieldProps as CoreComboboxSearchFieldProps, ComboboxSelectTriggerProps as CoreComboboxSelectTriggerProps, ComboboxListProps as CoreComboboxListProps, ComboboxItemProps as CoreComboboxItemProps, ComboboxItemAddNewProps as CoreComboboxItemAddNewProps, ComboboxEmptyProps as CoreComboboxEmptyProps, IconProps as CoreIconProps, AvatarProps as CoreAvatarProps } from '@servicetitan/hammer-react';
import { DataTrackingId } from '../../types/DataTrackingId';
import { DistributiveOmit } from '../../types';
export type ComboboxProps<Item> = CoreComboboxProps<Item>;
export type ComboboxSelectProps<Item> = CoreComboboxSelectProps<Item>;
export type ComboboxSearchFieldProps = DistributiveOmit<CoreComboboxSearchFieldProps, "prefix"> & DataTrackingId & {
    prefix?: string | {
        icon: DistributiveOmit<CoreIconProps, "size">;
    } | {
        avatar: DistributiveOmit<CoreAvatarProps, "size">;
    };
};
export type ComboboxSelectTriggerProps = DistributiveOmit<CoreComboboxSelectTriggerProps, "prefix"> & DataTrackingId & {
    prefix?: string | {
        icon: DistributiveOmit<CoreIconProps, "size">;
    } | {
        avatar: DistributiveOmit<CoreAvatarProps, "size">;
    };
};
export type ComboboxContentProps<Item> = CoreComboboxContentProps<Item>;
export type ComboboxListProps = CoreComboboxListProps;
export type ComboboxItemProps<Item> = CoreComboboxItemProps<Item> & DataTrackingId;
export type ComboboxItemAddNewProps<Item> = CoreComboboxItemAddNewProps<Item> & DataTrackingId;
export type ComboboxEmptyProps = CoreComboboxEmptyProps;
export declare const ComboboxElement: <Item = any>(props: ComboboxProps<Item>) => import("react/jsx-runtime").JSX.Element;
export declare const ComboboxSelect: <Item = any>(props: ComboboxSelectProps<Item>) => import("react/jsx-runtime").JSX.Element;
export declare const ComboboxSearchField: ({ prefix: prefixProp, ...props }: ComboboxSearchFieldProps) => import("react/jsx-runtime").JSX.Element;
export declare const ComboboxSelectTrigger: ({ prefix: prefixProp, ...props }: ComboboxSelectTriggerProps) => import("react/jsx-runtime").JSX.Element;
export declare const ComboboxContent: <Item = any>(props: ComboboxContentProps<Item>) => import("react/jsx-runtime").JSX.Element;
export declare const ComboboxList: <Item = any>(props: ComboboxListProps) => import("react/jsx-runtime").JSX.Element;
export declare const ComboboxItem: <Item = any>(props: ComboboxItemProps<Item>) => import("react/jsx-runtime").JSX.Element;
export declare const ComboboxItemAddNew: <Item = any>(props: ComboboxItemAddNewProps<Item>) => import("react/jsx-runtime").JSX.Element;
export declare const ComboboxEmpty: <Item = any>(props: ComboboxEmptyProps) => import("react/jsx-runtime").JSX.Element;
export declare const Combobox: (<Item = any>(props: ComboboxProps<Item>) => import("react/jsx-runtime").JSX.Element) & {
    Select: <Item = any>(props: ComboboxSelectProps<Item>) => import("react/jsx-runtime").JSX.Element;
    SearchField: ({ prefix: prefixProp, ...props }: ComboboxSearchFieldProps) => import("react/jsx-runtime").JSX.Element;
    SelectTrigger: ({ prefix: prefixProp, ...props }: ComboboxSelectTriggerProps) => import("react/jsx-runtime").JSX.Element;
    Content: <Item = any>(props: ComboboxContentProps<Item>) => import("react/jsx-runtime").JSX.Element;
    List: <Item = any>(props: ComboboxListProps) => import("react/jsx-runtime").JSX.Element;
    Item: <Item = any>(props: ComboboxItemProps<Item>) => import("react/jsx-runtime").JSX.Element;
    ItemAddNew: <Item = any>(props: ComboboxItemAddNewProps<Item>) => import("react/jsx-runtime").JSX.Element;
    Empty: <Item = any>(props: ComboboxEmptyProps) => import("react/jsx-runtime").JSX.Element;
};
