import { DialogProps as CoreDialogProps, DialogHeaderProps as CoreDialogHeaderProps, DialogFooterProps as CoreDialogFooterProps, DialogContentProps as CoreDialogContentProps, DialogCancelButtonProps as CoreDialogCancelButtonProps } from '@servicetitan/hammer-react';
import { DataTrackingId } from '../../types/DataTrackingId';
export type DialogProps = CoreDialogProps;
export type DialogHeaderProps = CoreDialogHeaderProps & DataTrackingId;
export type DialogFooterProps = CoreDialogFooterProps;
export type DialogContentProps = CoreDialogContentProps;
export type DialogCancelButtonProps = CoreDialogCancelButtonProps & DataTrackingId;
export declare const DialogHeader: import('react').ForwardRefExoticComponent<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLElement>, HTMLElement>, "ref"> & DataTrackingId & import('react').RefAttributes<HTMLDivElement>>;
export declare const DialogFooter: import('react').ForwardRefExoticComponent<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLElement>, HTMLElement>, "ref"> & {
    sticky?: boolean;
} & import('react').RefAttributes<HTMLDivElement>>;
export declare const DialogContent: import('react').ForwardRefExoticComponent<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLDivElement>, HTMLDivElement>, "ref"> & import('react').RefAttributes<HTMLDivElement>>;
export declare const DialogCancelButton: import('react').ForwardRefExoticComponent<DialogCancelButtonProps & import('react').RefAttributes<HTMLButtonElement>>;
export declare const Dialog: import('react').ForwardRefExoticComponent<Omit<import('react').DetailedHTMLProps<import('react').DialogHTMLAttributes<HTMLDialogElement>, HTMLDialogElement>, "ref"> & import('@servicetitan/hammer-react/dist/hooks/useDialogTransitionStates').DialogTransitionStateEffects & import('@servicetitan/hammer-react').DisableCloseOnEscapeOrClickProps & {
    fullScreen?: boolean;
    size?: Extract<import('@servicetitan/hammer-react').Size, "medium" | "large">;
    open?: boolean;
    onClose?: () => void;
    onOpen?: () => void;
    onOpenChange?: (open: boolean) => void;
    enableScrollChaining?: boolean;
} & import('react').RefAttributes<HTMLDialogElement>> & {
    Header: import('react').ForwardRefExoticComponent<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLElement>, HTMLElement>, "ref"> & DataTrackingId & import('react').RefAttributes<HTMLDivElement>>;
    Footer: import('react').ForwardRefExoticComponent<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLElement>, HTMLElement>, "ref"> & {
        sticky?: boolean;
    } & import('react').RefAttributes<HTMLDivElement>>;
    Content: import('react').ForwardRefExoticComponent<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLDivElement>, HTMLDivElement>, "ref"> & import('react').RefAttributes<HTMLDivElement>>;
    CancelButton: import('react').ForwardRefExoticComponent<DialogCancelButtonProps & import('react').RefAttributes<HTMLButtonElement>>;
};
