import { DrawerProps as CoreDrawerProps, DrawerCancelButtonProps as CoreDrawerCancelButtonProps, DrawerFooterProps as CoreDrawerFooterProps, DrawerHeaderProps as CoreDrawerHeaderProps, DrawerContentProps as CoreDrawerContentProps } from '@servicetitan/hammer-react';
import { DataTrackingId } from '../../types/DataTrackingId';
export type DrawerProps = CoreDrawerProps;
export type DrawerCancelButtonProps = CoreDrawerCancelButtonProps & DataTrackingId;
export type DrawerFooterProps = CoreDrawerFooterProps;
export type DrawerHeaderProps = CoreDrawerHeaderProps & DataTrackingId;
export type DrawerContentProps = CoreDrawerContentProps;
export declare const DrawerCancelButton: import('react').ForwardRefExoticComponent<DrawerCancelButtonProps & import('react').RefAttributes<HTMLButtonElement>>;
export declare const DrawerFooter: import('react').ForwardRefExoticComponent<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLElement>, HTMLElement>, "ref"> & {
    sticky?: boolean;
} & import('react').RefAttributes<HTMLDivElement>>;
export declare const DrawerHeader: import('react').ForwardRefExoticComponent<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLElement>, HTMLElement>, "ref"> & DataTrackingId & import('react').RefAttributes<HTMLDivElement>>;
export declare const DrawerContent: import('react').ForwardRefExoticComponent<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLDivElement>, HTMLDivElement>, "ref"> & import('react').RefAttributes<HTMLDivElement>>;
export declare const Drawer: import('react').ForwardRefExoticComponent<Omit<import('react').DetailedHTMLProps<import('react').DialogHTMLAttributes<HTMLDialogElement>, HTMLDialogElement>, "ref"> & import('@servicetitan/hammer-react/dist/hooks/useDialogTransitionStates').DialogTransitionStateEffects & import('@servicetitan/hammer-react').DisableCloseOnEscapeOrClickProps & {
    size?: Extract<import('@servicetitan/hammer-react').Size, "medium" | "large">;
    open?: boolean;
    onClose?: () => void;
    onOpen?: () => void;
    enableScrollChaining?: boolean;
} & import('react').RefAttributes<HTMLDialogElement>> & {
    Header: import('react').ForwardRefExoticComponent<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLElement>, HTMLElement>, "ref"> & DataTrackingId & import('react').RefAttributes<HTMLDivElement>>;
    Footer: import('react').ForwardRefExoticComponent<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLElement>, HTMLElement>, "ref"> & {
        sticky?: boolean;
    } & import('react').RefAttributes<HTMLDivElement>>;
    Content: import('react').ForwardRefExoticComponent<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLDivElement>, HTMLDivElement>, "ref"> & import('react').RefAttributes<HTMLDivElement>>;
    CancelButton: import('react').ForwardRefExoticComponent<DrawerCancelButtonProps & import('react').RefAttributes<HTMLButtonElement>>;
};
