import { LayoutUtilProps } from '@servicetitan/hammer-react';
import { ComponentPropsWithoutRef, ReactNode } from 'react';
import { BreadcrumbsLinkProps } from '../Breadcrumbs';
import { ButtonProps } from '../Button';
import { ButtonLinkProps } from '../ButtonLink';
import { ChipProps } from '../Chip';
import { LayoutProps } from '../Layout';
export type PageSidebarProps = ComponentPropsWithoutRef<"div"> & {
    localStorageKey?: string;
    ["data-tracking-id"]?: string;
    currentPageTitle?: string;
};
export declare const PageSidebar: import('react').ForwardRefExoticComponent<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLDivElement>, HTMLDivElement>, "ref"> & {
    localStorageKey?: string;
    "data-tracking-id"?: string;
    currentPageTitle?: string;
} & import('react').RefAttributes<HTMLDivElement>>;
export type PageSidebarHeaderProps = ComponentPropsWithoutRef<"div">;
export declare const PageSidebarHeader: import('react').ForwardRefExoticComponent<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLDivElement>, HTMLDivElement>, "ref"> & import('react').RefAttributes<HTMLDivElement>>;
export type PagePanelProps = ComponentPropsWithoutRef<"div"> & {
    open?: boolean;
    size?: "small" | "medium" | "large";
    noPadding?: boolean;
};
export declare const PagePanel: import('react').ForwardRefExoticComponent<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLDivElement>, HTMLDivElement>, "ref"> & {
    open?: boolean;
    size?: "small" | "medium" | "large";
    noPadding?: boolean;
} & import('react').RefAttributes<HTMLDivElement>>;
type PageHeaderActionProps = Omit<ButtonProps, "appearance"> & {
    label: string;
};
type PageHeaderActionsProps = {
    primary?: PageHeaderActionProps;
    secondary?: PageHeaderActionProps[];
};
type BasePreferenceProps = {
    "aria-label": string;
};
type PreferenceButtonProps = Omit<ButtonProps, "aria-label" | "icon" | "appearance" | "size" | "className"> & BasePreferenceProps;
type PreferenceLinkProps = Omit<ButtonLinkProps, "aria-label" | "icon" | "appearance" | "size" | "className"> & BasePreferenceProps;
export type PageHeaderProps = ComponentPropsWithoutRef<"header"> & {
    title: string;
    breadcrumbs?: BreadcrumbsLinkProps[];
    chips?: ChipProps[];
    description?: ReactNode;
    actions?: PageHeaderActionsProps;
    preferenceAction?: PreferenceButtonProps | PreferenceLinkProps;
    layout?: LayoutProps;
};
export declare const PageHeader: import('react').ForwardRefExoticComponent<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLElement>, HTMLElement>, "ref"> & {
    title: string;
    breadcrumbs?: BreadcrumbsLinkProps[];
    chips?: ChipProps[];
    description?: ReactNode;
    actions?: PageHeaderActionsProps;
    preferenceAction?: PreferenceButtonProps | PreferenceLinkProps;
    layout?: LayoutProps;
} & import('react').RefAttributes<HTMLHeadElement>>;
export type PageContentProps = ComponentPropsWithoutRef<"main">;
export declare const PageContent: import('react').ForwardRefExoticComponent<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLElement>, HTMLElement>, "ref"> & import('react').RefAttributes<HTMLAreaElement>>;
export type PageProps = ComponentPropsWithoutRef<"div">;
export type PageFooterProps = ComponentPropsWithoutRef<"div"> & LayoutUtilProps;
export declare const Page: import('react').ForwardRefExoticComponent<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLDivElement>, HTMLDivElement>, "ref"> & import('react').RefAttributes<HTMLDivElement>> & {
    Sidebar: import('react').ForwardRefExoticComponent<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLDivElement>, HTMLDivElement>, "ref"> & {
        localStorageKey?: string;
        "data-tracking-id"?: string;
        currentPageTitle?: string;
    } & import('react').RefAttributes<HTMLDivElement>>;
    SidebarHeader: import('react').ForwardRefExoticComponent<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLDivElement>, HTMLDivElement>, "ref"> & import('react').RefAttributes<HTMLDivElement>>;
    Header: import('react').ForwardRefExoticComponent<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLElement>, HTMLElement>, "ref"> & {
        title: string;
        breadcrumbs?: BreadcrumbsLinkProps[];
        chips?: ChipProps[];
        description?: ReactNode;
        actions?: PageHeaderActionsProps;
        preferenceAction?: PreferenceButtonProps | PreferenceLinkProps;
        layout?: LayoutProps;
    } & import('react').RefAttributes<HTMLHeadElement>>;
    Content: import('react').ForwardRefExoticComponent<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLElement>, HTMLElement>, "ref"> & import('react').RefAttributes<HTMLAreaElement>>;
    Panel: import('react').ForwardRefExoticComponent<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLDivElement>, HTMLDivElement>, "ref"> & {
        open?: boolean;
        size?: "small" | "medium" | "large";
        noPadding?: boolean;
    } & import('react').RefAttributes<HTMLDivElement>>;
    Footer: import('react').ForwardRefExoticComponent<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLDivElement>, HTMLDivElement>, "ref"> & LayoutUtilProps & import('react').RefAttributes<HTMLDivElement>>;
};
export {};
