import { StepperProps as CoreStepperProps, StepperListProps as CoreStepperListProps, StepperStepProps as CoreStepperStepProps, StepperPanelProps as CoreStepperPanelProps, StepperNextButtonProps as CoreStepperNextButtonProps, StepperPrevButtonProps as CoreStepperPrevButtonProps, StepperFinalPanelProps as CoreStepperFinalPanelProps } from '@servicetitan/hammer-react';
import { DataTrackingId } from '../../types/DataTrackingId';
export type StepperProps = CoreStepperProps;
export type StepperListProps = CoreStepperListProps;
export type StepperStepProps = CoreStepperStepProps;
export type StepperPanelProps = CoreStepperPanelProps;
export type StepperNextButtonProps = CoreStepperNextButtonProps & DataTrackingId;
export type StepperPrevButtonProps = CoreStepperPrevButtonProps & DataTrackingId;
export type StepperFinalPanelProps = CoreStepperFinalPanelProps;
export declare const StepperList: import('react').ForwardRefExoticComponent<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLDivElement>, HTMLDivElement>, "ref"> & import('react').RefAttributes<HTMLDivElement>>;
export declare const StepperStep: import('react').ForwardRefExoticComponent<Omit<Omit<import('react').DetailedHTMLProps<import('react').ButtonHTMLAttributes<HTMLButtonElement>, HTMLButtonElement>, "ref">, "onClick" | "disabled"> & {
    controls: string;
    onClick?: (e: import('react').MouseEvent<HTMLButtonElement>, index?: number) => void;
} & import('react').RefAttributes<HTMLButtonElement>>;
export declare const StepperPanel: import('react').ForwardRefExoticComponent<Omit<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLDivElement>, HTMLDivElement>, "ref">, "onDrag" | "onDragEnd" | "onDragStart" | "onAnimationStart"> & import('@servicetitan/hammer-react').LayoutUtilProps & {
    id: string;
} & import('react').RefAttributes<HTMLDivElement>>;
export declare const StepperFinalPanel: import('react').ForwardRefExoticComponent<Omit<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLDivElement>, HTMLDivElement>, "ref">, "onDrag" | "onDragEnd" | "onDragStart" | "onAnimationStart"> & import('@servicetitan/hammer-react').LayoutUtilProps & import('react').RefAttributes<HTMLDivElement>>;
export declare const StepperNextButton: import('react').ForwardRefExoticComponent<Omit<import('@servicetitan/hammer-react').ButtonProps, "children"> & {
    nextLabel?: string;
    completeLabel?: string;
    onClick?: (e: import('react').MouseEvent<HTMLButtonElement>) => void | boolean | Promise<boolean>;
} & DataTrackingId & import('react').RefAttributes<HTMLButtonElement>>;
export declare const StepperPrevButton: import('react').ForwardRefExoticComponent<Omit<import('@servicetitan/hammer-react').ButtonProps, "children"> & {
    label?: string;
} & DataTrackingId & import('react').RefAttributes<HTMLButtonElement>>;
export declare const Stepper: import('react').ForwardRefExoticComponent<Omit<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLDivElement>, HTMLDivElement>, "ref">, "onChange" | "onDrag" | "onDragEnd" | "onDragStart" | "onAnimationStart"> & import('@servicetitan/hammer-react').LayoutUtilProps & {
    defaultIndex?: number;
    allowNavigateToPrevStep?: boolean;
    onChange?: (data: {
        currentStepId: string | "final-panel";
        currentStepIndex?: number;
    }) => void;
    onComplete?: () => void;
} & import('react').RefAttributes<HTMLDivElement>> & {
    List: import('react').ForwardRefExoticComponent<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLDivElement>, HTMLDivElement>, "ref"> & import('react').RefAttributes<HTMLDivElement>>;
    Step: import('react').ForwardRefExoticComponent<Omit<Omit<import('react').DetailedHTMLProps<import('react').ButtonHTMLAttributes<HTMLButtonElement>, HTMLButtonElement>, "ref">, "onClick" | "disabled"> & {
        controls: string;
        onClick?: (e: import('react').MouseEvent<HTMLButtonElement>, index?: number) => void;
    } & import('react').RefAttributes<HTMLButtonElement>>;
    Panel: import('react').ForwardRefExoticComponent<Omit<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLDivElement>, HTMLDivElement>, "ref">, "onDrag" | "onDragEnd" | "onDragStart" | "onAnimationStart"> & import('@servicetitan/hammer-react').LayoutUtilProps & {
        id: string;
    } & import('react').RefAttributes<HTMLDivElement>>;
    FinalPanel: import('react').ForwardRefExoticComponent<Omit<Omit<import('react').DetailedHTMLProps<import('react').HTMLAttributes<HTMLDivElement>, HTMLDivElement>, "ref">, "onDrag" | "onDragEnd" | "onDragStart" | "onAnimationStart"> & import('@servicetitan/hammer-react').LayoutUtilProps & import('react').RefAttributes<HTMLDivElement>>;
    NextButton: import('react').ForwardRefExoticComponent<Omit<import('@servicetitan/hammer-react').ButtonProps, "children"> & {
        nextLabel?: string;
        completeLabel?: string;
        onClick?: (e: import('react').MouseEvent<HTMLButtonElement>) => void | boolean | Promise<boolean>;
    } & DataTrackingId & import('react').RefAttributes<HTMLButtonElement>>;
    PrevButton: import('react').ForwardRefExoticComponent<Omit<import('@servicetitan/hammer-react').ButtonProps, "children"> & {
        label?: string;
    } & DataTrackingId & import('react').RefAttributes<HTMLButtonElement>>;
};
