import { ToolbarProps as CoreToolbarProps, ToolbarButtonProps as CoreToolbarButtonProps, ToolbarButtonToggleProps as CoreToolbarButtonToggleProps, ToolbarButtonLinkProps as CoreToolbarButtonLinkProps, ToolbarSelectProps as CoreToolbarSelectProps, ToolbarOverflowTypes as CoreToolbarOverflowTypes, ToolbarItemAppearance as CoreToolbarItemAppearance } from '@servicetitan/hammer-react';
import { DataTrackingId } from '../../types/DataTrackingId';
export type ToolbarProps = CoreToolbarProps & DataTrackingId;
export type ToolbarButtonProps = CoreToolbarButtonProps & DataTrackingId;
export type ToolbarButtonToggleProps = CoreToolbarButtonToggleProps & DataTrackingId;
export type ToolbarButtonLinkProps = CoreToolbarButtonLinkProps & DataTrackingId;
export type ToolbarSelectProps<T> = CoreToolbarSelectProps<T> & DataTrackingId;
export type ToolbarOverflowTypes = CoreToolbarOverflowTypes;
export type ToolbarItemAppearance = CoreToolbarItemAppearance;
export declare function ToolbarElement(props: ToolbarProps): import("react/jsx-runtime").JSX.Element;
export declare function ToolbarButton(props: ToolbarButtonProps): import("react/jsx-runtime").JSX.Element;
export declare function ToolbarButtonToggle(props: ToolbarButtonToggleProps): import("react/jsx-runtime").JSX.Element;
export declare function ToolbarButtonLink(props: ToolbarButtonLinkProps): import("react/jsx-runtime").JSX.Element;
export declare function ToolbarSelect(props: ToolbarSelectProps<unknown>): import("react/jsx-runtime").JSX.Element;
export declare const Toolbar: typeof ToolbarElement & {
    Button: typeof ToolbarButton;
    ButtonToggle: typeof ToolbarButtonToggle;
    ButtonLink: typeof ToolbarButtonLink;
    Select: typeof ToolbarSelect;
};
