import { jsx } from 'react/jsx-runtime';
import { I as Icon } from './Icon-BrdmZw1i-CG-LzgEz.js';
import * as React from 'react';
import { forwardRef } from 'react';
import { c as cx } from './index-tZvMCc77.js';
import { B as ButtonCompound } from './ButtonCompound-Dp5J4W81-BkZ68L4-.js';

import './index-CdSSO4ct.css';const SvgDragIndicator = (props) => /* @__PURE__ */ React.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", width: "1em", height: "1em", viewBox: "0 0 24 24", ...props }, /* @__PURE__ */ React.createElement("path", { d: "M11 18c0 1.1-.9 2-2 2s-2-.9-2-2 .9-2 2-2 2 .9 2 2zm-2-8c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm0-6c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm6 4c1.1 0 2-.9 2-2s-.9-2-2-2-2 .9-2 2 .9 2 2 2zm0 2c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm0 6c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2z" }));

const handle = "_handle_z85jk_2";
const active = "_active_z85jk_24";
const handleStyles = {
	handle: handle,
	"handle-button": "_handle-button_z85jk_9",
	active: active
};

function DndHandle({ className }) {
  const handleClasses = cx(handleStyles.handle, className);
  return /* @__PURE__ */ jsx(Icon, { svg: SvgDragIndicator, className: handleClasses, role: "presentation" });
}

const DndHandleButton = forwardRef(({ isActive = false, className, ...props }, ref) => {
  const handleButtonClasses = cx(className, handleStyles["handle-button"], {
    [handleStyles["active"]]: isActive
  });
  return /* @__PURE__ */ jsx(
    ButtonCompound,
    {
      ref,
      className: handleButtonClasses,
      type: "button",
      shape: "rounded",
      ...props,
      children: /* @__PURE__ */ jsx(DndHandle, {})
    }
  );
});
DndHandleButton.displayName = "DndHandleButton";

const styles = {
	"drop-line": "_drop-line_k30eq_3",
	"drag-preview": "_drag-preview_k30eq_18",
	"orientation-horizontal": "_orientation-horizontal_k30eq_36",
	"position-before": "_position-before_k30eq_40",
	"position-after": "_position-after_k30eq_44",
	"orientation-vertical": "_orientation-vertical_k30eq_52",
	"drop-zone": "_drop-zone_k30eq_66",
	"can-be-dropped": "_can-be-dropped_k30eq_71",
	"active-not-over": "_active-not-over_k30eq_75",
	"over-valid": "_over-valid_k30eq_82",
	"over-invalid": "_over-invalid_k30eq_86"
};

const DndSortLine = ({
  offset,
  orientation,
  position,
  ...rest
}) => {
  const classes = cx(
    styles["drop-line"],
    styles[`orientation-${orientation}`],
    styles[`position-${position}`]
  );
  return /* @__PURE__ */ jsx(
    "div",
    {
      "aria-hidden": true,
      className: classes,
      style: { "--drop-line-offset": offset },
      ...rest
    }
  );
};

const DndZone = forwardRef(
  ({
    el: Component = "div",
    children,
    className,
    isDragging,
    isOver,
    isValid,
    ...rest
  }, ref) => {
    const classes = cx(className, {
      [styles["drop-zone"]]: true,
      [styles["over-valid"]]: isDragging && isOver && isValid,
      [styles["over-invalid"]]: isDragging && isOver && !isValid,
      [styles["active-not-over"]]: isDragging && !isOver
    });
    return /* @__PURE__ */ jsx(Component, { ref, className: classes, ...rest, children });
  }
);
DndZone.displayName = "DndZoneBase";

const Dnd = {
  Handle: DndHandle,
  HandleButton: DndHandleButton,
  SortLine: DndSortLine,
  Zone: DndZone
};

export { Dnd as D, DndHandleButton as a, DndHandle as b, DndSortLine as c, styles as s };
//# sourceMappingURL=index-CdSSO4ct-elKOdXPf.js.map
