export const common = {
	BorderRadiusNone: "0",
	BorderRadiusSmall: "0.1875rem",
	BorderRadiusMedium: "0.375rem",
	BorderRadiusLarge: "0.75rem",
	BorderRadiusXlarge: "1.5rem",
	BorderRadiusCircular: "100%",
	BorderWidthNone: "0rem",
	BorderWidth: "0.0625rem",
	BorderWidthStrong: "0.125rem",
	FocusRingWidth: "0.25rem",
	ShadowSizeFlat: "0rem 0rem 0rem",
	ShadowSizeFloat: "0rem 0.125rem 0.5rem",
	ShadowSizeOverlay: "0rem 0.5rem 1.5rem",
	TypographyParagraphSizeXsmall: "0.75rem",
	TypographyParagraphSizeSmall: "0.875rem",
	TypographyParagraphSize: "1rem",
	TypographyParagraphSizeLarge: "1.25rem",
	TypographyParagraphSizeXlarge: "1.5rem",
	TypographyParagraphFontWeight: 400,
	TypographyParagraphFontFamily: "'Nunito Sans', sans-serif",
	TypographyHeadingSizeXsmall: "0.875rem",
	TypographyHeadingSizeSmall: "1rem",
	TypographyHeadingSize: "1.25rem",
	TypographyHeadingSizeLarge: "1.5rem",
	TypographyHeadingSizeXlarge: "2rem",
	TypographyHeadingFontWeight: 700,
	TypographyHeadingFontFamily: "'Sofia Pro', SofiaPro, sans-serif",
	TypographyLabelSizeXsmall: "0.625rem",
	TypographyLabelSizeSmall: "0.75rem",
	TypographyLabelSize: "0.875rem",
	TypographyLabelSizeLarge: "1rem",
	TypographyLabelSizeXlarge: "1.25rem",
	TypographyLabelFontWeight: 600,
	TypographyLabelFontFamily: "'Nunito Sans', sans-serif"
}
export const light = {
	BackgroundColor: "#ffffff",
	BackgroundColorStrong: "#f7f7f7",
	BackgroundColorStronger: "#eeeeee",
	BackgroundColorStrongest: "#bcbcbd",
	BackgroundColorPrimary: "#0265DC",
	BackgroundColorPrimarySubdued: "#E0F2FF",
	BackgroundColorSuccess: "#007A4D",
	BackgroundColorSuccessSubdued: "#CEF8E0",
	BackgroundColorDanger: "#e13212",
	BackgroundColorDangerSubdued: "#ffece9",
	BackgroundColorWarning: "#ffbe00",
	BackgroundColorDisabled: "#606162",
	BackgroundColorInverted: "#2d2e31",
	BackgroundColorInvertedStrong: "#141414",
	BorderColor: "#949596",
	BorderColorSubdued: "#dfe0e1",
	BorderColorStrong: "#444445",
	BorderColorPrimary: "#0265DC",
	BorderColorSuccess: "#007A4D",
	BorderColorDanger: "#e13212",
	FocusRingColor: "#0265DC",
	FocusRingColorDanger: "#e13212",
	ForegroundColor: "#141414",
	ForegroundColorSubdued: "#737475",
	ForegroundColorPrimary: "#0265DC",
	ForegroundColorDanger: "#e13212",
	ForegroundColorInverted: "#ffffff",
	ForegroundColorOnPrimary: "#ffffff",
	ForegroundColorOnDanger: "#ffffff",
	ForegroundColorOnDangerSubdued: "#bf2a00",
	ForegroundColorOnWarning: "#141414",
	ForegroundColorActivePrimary: "#004491",
	ForegroundColorActiveDanger: "#bf2a00",
	ForegroundColorHoverPrimary: "#004491",
	ForegroundColorHoverDanger: "#bf2a00",
	OverlayColorActive: "#14141429",
	OverlayColorActivePrimary: "#0265DC4D",
	OverlayColorActiveDanger: "#e132124D",
	OverlayColorActiveOn: "#14141429",
	OverlayColorActiveOnPrimary: "#14141466",
	OverlayColorActiveOnDanger: "#14141466",
	OverlayColorHover: "#14141414",
	OverlayColorHoverPrimary: "#0265DC1A",
	OverlayColorHoverDanger: "#e132121A",
	OverlayColorHoverOn: "#14141414",
	OverlayColorHoverOnPrimary: "#14141433",
	OverlayColorHoverOnDanger: "#14141433",
	ShadowColor: "#14141414",
	StatusColorInfo: "#0265DC",
	StatusColorDanger: "#e13212",
	StatusColorSuccess: "#007A4D",
	StatusColorWarning: "#ffbe00"
}
export const dark = {
	BackgroundColor: "#141414",
	BackgroundColorStrong: "#2d2e31",
	BackgroundColorStronger: "#444445",
	BackgroundColorStrongest: "#737475",
	BackgroundColorPrimary: "#78BBFA",
	BackgroundColorPrimarySubdued: "#78BBFA33",
	BackgroundColorSuccess: "#49CC93",
	BackgroundColorSuccessSubdued: "#49CC9333",
	BackgroundColorDanger: "#ff745f",
	BackgroundColorDangerSubdued: "#ff745f33",
	BackgroundColorWarning: "#ffe278",
	BackgroundColorDisabled: "#606162",
	BackgroundColorInverted: "#fafafa",
	BackgroundColorInvertedStrong: "#ffffff",
	BorderColor: "#606162",
	BorderColorSubdued: "#444445",
	BorderColorStrong: "#dfe0e1",
	BorderColorPrimary: "#78BBFA",
	BorderColorSuccess: "#49CC93",
	BorderColorDanger: "#ff745f",
	FocusRingColor: "#78BBFA",
	FocusRingColorDanger: "#ff745f",
	ForegroundColor: "#ffffff",
	ForegroundColorSubdued: "#bcbcbd",
	ForegroundColorPrimary: "#78BBFA",
	ForegroundColorDanger: "#ff745f",
	ForegroundColorInverted: "#141414",
	ForegroundColorOnPrimary: "#141414",
	ForegroundColorOnDanger: "#141414",
	ForegroundColorOnDangerSubdued: "#ffffff",
	ForegroundColorOnWarning: "#141414",
	ForegroundColorActivePrimary: "#B5DEFF",
	ForegroundColorActiveDanger: "#ff745f",
	ForegroundColorHoverPrimary: "#B5DEFF",
	ForegroundColorHoverDanger: "#ff745f",
	OverlayColorActive: "#ffffff29",
	OverlayColorActivePrimary: "#78BBFA40",
	OverlayColorActiveDanger: "#f94d3240",
	OverlayColorActiveOn: "#14141429",
	OverlayColorActiveOnPrimary: "#14141429",
	OverlayColorActiveOnDanger: "#14141429",
	OverlayColorHover: "#ffffff14",
	OverlayColorHoverPrimary: "#78BBFA1A",
	OverlayColorHoverDanger: "#f94d3226",
	OverlayColorHoverOn: "#ffffff14",
	OverlayColorHoverOnPrimary: "#ffffff29",
	OverlayColorHoverOnDanger: "#ffffff29",
	ShadowColor: "#ffffff14",
	StatusColorInfo: "#78BBFA",
	StatusColorDanger: "#ff745f",
	StatusColorSuccess: "#49CC93",
	StatusColorWarning: "#ffe278"
}
