/**
 * Use to Omit props from types that include unions.
 *
 * Example:
 * type A = {
 *   prop?: string;
 *   otherProp?: false;
 * } | {
 *   prop: string;
 *   otherProp: true;
 * };
 * type B = A & { thirdProp: boolean; };
 * type C = DistributiveOmit<C, "thirdProp">;
 */
export type DistributiveOmit<T, K extends keyof any> = T extends any ? Omit<T, K> : never;
